/**
 * DirectMessages의 기능을 수행하는 클래스
 * @class DirectMessages의 기능을 수행하는 클래스
 */
var DirectMessages =
{
	direct_messages_list : Array(),
	sent_direct_messages_list : null,
	senddirectmessage_return_func : null,
	
	getdirectmessages_return_func : null,
	getsentdirectmessages_return_func : null,
	delete_return_func : null,
	senddirectmessage_error_func : null,
	
	COUNT_IN_PAGE : 100
}

DirectMessages.SetSendDirectMessageReturnFunc = function(func)
{
	this.senddirectmessage_return_func = func;	
}

DirectMessages.SetSendDirectMessageErrorFunc = function(func)
{
	this.senddirectmessage_error_func = func;	
}


DirectMessages.SetGetDirectMessageReturnFunc = function(func)
{
	this.getdirectmessages_return_func = func;	
}

DirectMessages.SetGetSentDirectMessageReturnFunc = function(func)
{
	this.getsentdirectmessages_return_func = func;	
}


//자신에게 온  DirectMessage 데이터를 받는 곳.
DirectMessages.OnDirectMessagesReceive = function(httpRequest, load_no)
{
	alert("DirectMessages.OnDirectMessagesReceive()");
	Test(httpRequest, null, "httpRequest가 null");
	
	DirectMessages.direct_messages_list = DirectMessageMaker.MakeDirectMessageList(httpRequest.responseXML);
	DirectMessages.PrintList(DirectMessages.direct_messages_list);
	
	if(DirectMessages.getdirectmessages_return_func)
		DirectMessages.getdirectmessages_return_func(DirectMessages.direct_messages_list, load_no);
}

//자신이 보낸 DirectMessage 데이터를 받는 곳.
DirectMessages.OnSentDirectMessagesReceive = function(httpRequest, load_no)
{
	alert("DirectMessages.OnSentDirectMessagesReceive()");
	Test(httpRequest, null, "httpRequest가 null");
	
	DirectMessages.sent_direct_messages_list = DirectMessageMaker.MakeDirectMessageList(httpRequest.responseXML);
	DirectMessages.PrintList(DirectMessages.sent_direct_messages_list);
	
	if(DirectMessages.getsentdirectmessages_return_func)
		DirectMessages.getsentdirectmessages_return_func(DirectMessages.sent_direct_messages_list, load_no);
}

//다이렉트 메시지를 보낸 후 응답을 받는 곳
DirectMessages.OnSendDirectMessage = function(httpRequest)
{
	alert("DirectMessages.OnSendDirectMessage()");
	Test(httpRequest, null, "httpRequest가 null");
	
	if (DirectMessages.senddirectmessage_return_func) 
	{
		DirectMessages.senddirectmessage_return_func();
	}
}

//다이렉트 메시지를 보낸 후 에러가 나면 응답을 받는 곳
DirectMessages.OnSendDirectMessageError = function(httpRequest)
{
	alert("DirectMessages.OnSendDirectMessageError()");
	Test(httpRequest, null, "httpRequest가 null");
	
	if (DirectMessages.senddirectmessage_error_func) 
		DirectMessages.senddirectmessage_error_func(httpRequest);
}

DirectMessages.SetDeleteReturnFunc = function(func)
{
	this.delete_return_func = func;
}

DirectMessages.OnDeleteReceive = function(httpRequest)
{
	alert("DirectMessage.OnDeleteReceive()");
	alert("삭제성공!");
	
	if(DirectMessages.delete_return_func)
		DirectMessages.delete_return_func();
}
	
DirectMessages.Delete = function(Id, async)
{
	alert("DirectMessage.Delete()");
	TwitterConsumer.Init("post", DIRECTMESSAGES_DELETE_URL + Id + ".xml");		
	TwitterConsumer.SetOnReceive(DirectMessages.OnDeleteReceive);
	TwitterConsumer.Request(async);
}

//자신에게 온 다이렉트 메시지들을 가져온다.
DirectMessages.GetDirectMessages = function(load_no, async)
{
	alert("DirectMessages.GetDirectMessages() " + load_no);
	TwitterConsumer.Init("get", DIRECTMESSAGES_URL + "?count=" + this.COUNT_IN_PAGE + "&page=" +load_no);
	TwitterConsumer.SetAdditionalInfo(load_no);
	TwitterConsumer.SetOnReceive(DirectMessages.OnDirectMessagesReceive);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);	
}

//자신이 보낸 다이렉트 메시지들을 가져온다.
DirectMessages.GetSentDirectMessages = function(load_no, async)
{
	alert("DirectMessages.GetSentDirectMessages()" + load_no);
	TwitterConsumer.Init("get", SENT_DIRECTMESSAGES_URL + "?count=" + this.COUNT_IN_PAGE + "&page=" +load_no);
	TwitterConsumer.SetAdditionalInfo(load_no);
	TwitterConsumer.SetOnReceive(DirectMessages.OnSentDirectMessagesReceive);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}

//다이렉트 메시지를 보낸다.
DirectMessages.SendDirectMessage = function(user, text)
{
	alert("DirectMessages.SendDirectMessage() ->" + user);
	alert(SEND_DIRECTMESSAGE_URL + "?user=" + user + "&text=" + text);
	TwitterConsumer.Init("post", SEND_DIRECTMESSAGE_URL + "?user=" + user + "&text=" + text);
	alert(SEND_DIRECTMESSAGE_URL);
	TwitterConsumer.SetOnReceive(DirectMessages.OnSendDirectMessage);
	TwitterConsumer.SetOnErrorReceive(DirectMessages.OnSendDirectMessageError);
	TwitterConsumer.Request();
}

//디버그용 다이렉트 메시지 내용 출력
DirectMessages.PrintList = function(list)
{
	Test(list, null, "DirectMessages.PrintList의 list가 null");
	if(list == null)
		return;
	for (var i = 0; i < list.length; i++) 
	{
		alert(list[i].Id);
		alert(list[i].SenderId);
		alert(list[i].Text);
		alert(list[i].RecipientId);
		alert(list[i].CreatedAt);
		alert(list[i].SenderScreenName);
		alert(list[i].RecipientScreenName);		
	}
}
