/**
 * Favorites 기능을 수행하는 클래스
 * @class Favorites 기능을 수행하는 클래스
 */
var Favorites =
{
	create_favorite_return_func : null,
	destroy_favorite_return_func : null,
	get_favorite_return_func : null,
	create_favorite_401_func : null,
	create_favorite_error_func : null,
	destroy_favorite_error_func : null, 
	
	COUNT_IN_PAGE : 100
}

Favorites.OnCreateFavoriteSuccessful = function(httpRequest)
{
	alert("Favorites.OnCreateFavoriteSuccessful()");
	alert("Favorites 등록 성공!");
	Test(httpRequest, null, "httpRequest가 null");
	
	if(Favorites.create_favorite_return_func)
		Favorites.create_favorite_return_func();
}

Favorites.OnCreateFavorite401 = function(httpRequest)
{
	alert("Favorites.OnCreateFavorite401()");
	alert("Favorites 등록 실 패!");
	Test(httpRequest, null, "httpRequest가 null");
	
	if(Favorites.create_favorite_401_func)
		Favorites.create_favorite_401_func();
}

Favorites.OnCreateFavoriteError = function(httpRequest)
{
	alert("Favorites.OnCreateFavoriteError()");
	alert("Favorites 등록 실패!");
	Test(httpRequest, null, "httpRequest가 null");
	
	if(Favorites.create_favorite_error_func)
		Favorites.create_favorite_error_func();
}

Favorites.SetCreateFavoriteReturnFunc = function(func)
{
	this.create_favorite_return_func = func;
}

Favorites.SetCreateFavorite401 = function(func)
{
	this.create_favorite_401_func = func;
}

Favorites.SetCreateFavoriteErrorFunc = function(func)
{
	this.create_favorite_error_func = func;
}

Favorites.CreateFavorite = function(status_id, async)
{
	alert("Favorites.CreateFavorite()");
	alert(FAVORITE_CREATE_URL + status_id + ".xml");
	
	TwitterConsumer.Init("post", FAVORITE_CREATE_URL + status_id + ".xml");
	TwitterConsumer.SetOnReceive(Favorites.OnCreateFavoriteSuccessful);
	TwitterConsumer.SetOn401Receive(Favorites.OnCreateFavorite401);
	TwitterConsumer.SetOnErrorReceive(Favorites.OnCreateFavoriteError);
	TwitterConsumer.Request(async);
}

Favorites.SetDestroyFavoriteReturnFunc = function(func)
{
	this.destroy_favorite_return_func = func;
}

Favorites.SetDestroyFavorite401Func = function(func)
{
	this.destroy_favorite_401_func = func;
}

Favorites.SetDestroyFavoriteErrorFunc = function(func)
{
	this.destroy_favorite_error_func = func;
}

Favorites.OnDestroyFavoriteSuccessful = function(httpRequest)
{
	alert("Favorites.OnDestroyFavoriteSuccessful()");
	alert("Favorites 삭제 성공!")
	Test(httpRequest, null, "httpRequest가 null");
	if(Favorites.destroy_favorite_return_func)
		Favorites.destroy_favorite_return_func();
}

Favorites.OnDestroyFavorite401 = function(httpRequest)
{
	alert("Favorites.OnDestroyFavorite401()");
	alert("Favorites 삭제 실패!")
	Test(httpRequest, null, "httpRequest가 null");
	if(Favorites.destroy_favorite_401_func)
		Favorites.destroy_favorite_401_func();
}

Favorites.OnDestroyFavoriteError = function(httpRequest)
{
	alert("Favorites.OnDestroyFavoriteError()");
	alert("Favorites 삭제 실패!")
	Test(httpRequest, null, "httpRequest가 null");
	if(Favorites.destroy_favorite_error_func)
		Favorites.destroy_favorite_error_func();
}

Favorites.DestroyFavorite = function(status_id, async)
{
	alert("Favorites.DestroyFavorite()");
	alert(FAVORITE_DESTROY_URL + status_id + ".xml");
	TwitterConsumer.Init("post", FAVORITE_DESTROY_URL + status_id + ".xml");
	
	TwitterConsumer.SetOnReceive(Favorites.OnDestroyFavoriteSuccessful);
	TwitterConsumer.SetOn401Receive(Favorites.OnDestroyFavorite401);
	TwitterConsumer.SetOnErrorReceive(Favorites.OnDestroyFavoriteError);
	TwitterConsumer.Request(async);
}

Favorites.SetFavoritesListReturnFunc = function(func)
{
	Favorites.get_favorite_return_func = func;
}

Favorites.OnGetFavoritesListSuccessful = function(httpRequest, load_no)
{
	alert("Favorites.OnGetFavoritesListSuccessful()");
	alert("Favorites 리스트 얻기 성공!")
	
	var favorite_list = StatusUserMaker.MakeStatusUserList(httpRequest.responseXML);
		
	if(Favorites.get_favorite_return_func)
		Favorites.get_favorite_return_func(favorite_list, load_no);
}

Favorites.GetFavoritesList = function(id, load_no, async)
{
	alert("Favorites.GetFavoritesList()");
	alert(FAVORITE_GET_URL + "?id=" + id);
	TwitterConsumer.Init("get", FAVORITE_GET_URL + "?id=" + id + "&page=" + load_no);
	TwitterConsumer.SetAdditionalInfo(load_no);
	TwitterConsumer.SetOnReceive(Favorites.OnGetFavoritesListSuccessful);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}
