/**
 * Following/Followers를 얻어오는 기능을 하는 클래스
 * @class Following/Followers를 얻어오는 기능을 하는 클래스
 */
var People =
{	
	username_list : null,
	following_id_list : null,
	followers_id_list : null,
	
	following_table : Array(),
	current_following_table : Array(),
	followers_table : Array(),
	current_followers_table : Array(),
	
	following_loaded_count : 0,
	follower_loaded_count : 0,
	following_temp_count : 0,
	follower_temp_count : 0,
	
	follower_table_return_func : null,
	following_table_return_func : null,
	
	following_return_func : null,
	followers_return_func : null,
	following_followers_return_func : null,
	
	following_user_return_func : null,
	followers_user_return_func : null,
	
	user_return_func : null,
	
	following_page_no : null,
	follower_page_no : null,
	
	get_following_user_id : null,
	get_following_user_count : 0,
	
	get_followers_user_id : null,
	get_followers_user_count : 0,
	
	is_first_loading : true,
	
	directmessages_user_id_list : null,
	
	COUNT_IN_PAGE : 4
	
	, quantityOfFollowings : 0
	, quantityOfFollowers : 0
	, quantityOfTweets : 0
}

People.setFollowingsQuantity = function(pQuantity) {
	this.quantityOfFollowings = pQuantity;
}

People.setFollowersQuantity = function(pQuantity) {
	this.quantityOfFollowers = pQuantity;
}

People.setTweetsQuantity = function(pQuantity) {
	this.quantityOfTweets = pQuantity;
}

People.getFollowingsQuantity = function() {
	return this.quantityOfFollowings;
}

People.getFollowersQuantity = function() {
	return this.quantityOfFollowers;
}

People.getTweetsQuantity = function() {
	return this.quantityOfTweets;
}

People.SetFollowingIdList = function(pList)
{
	this.following_id_list = pList;
}

People.SetFollowersIdList = function(pList)
{
	this.followers_id_list = pList;
}

People.GetFollowingIdList = function()
{
	return this.following_id_list;
}

People.GetFollowersIdList = function()
{
	return this.followers_id_list;	
}

People.ContainFollowingId = function(pID)
{
	alert("People.ContainFollowingId("+pID+")");
	
	TWAlert_(this.following_id_list);
	
	if (this.following_id_list instanceof Array) {
		for (var i = 0; i < this.following_id_list.length; i++) {
			if (this.following_id_list[i] == pID) 
				return true;
		}
	}
	return false;
}

People.ContainFollowersId = function(pID)
{
	alert("People.ContainFollowersId("+pID+")");
	
	TWAlert_(this.followers_id_list);
	
	if (this.followers_id_list instanceof Array) {
		for (var i = 0; i < this.followers_id_list.length; i++) {
			if (this.followers_id_list[i] == pID) 
				return true;
		}
	}
	return false;
}

People.AddFollowingID = function(pID) {
	if (!People.following_id_list) 
		People.following_id_list = new Array();
	People.following_id_list.push(pID);
}

People.RemoveFollowingID = function(pID){
	People.following_id_list = Util.RemoveArrayElement(People.following_id_list, pID);
}

People.GetFollowingCount = function()
{
	return this.following_id_list.length;	
}

People.GetFollowerCount = function()
{
	return this.follower_id_list.length;	
}
//////////////////////////////////////////////////////////////////////
People.OnGetFollowingSuccessful = function(httpRequest)
{
	alert("People.OnGetFollowingSuccessful()");
	Test(httpRequest, null, "httpRequest가 null");
	People.SetFollowingIdList(People.MakeIdList(httpRequest.responseXML));
	
	if(People.following_return_func)
		People.following_return_func();
}

People.GetFollowing = function(id, async)
{
	alert("People.GetFollowing()");
	TwitterConsumer.Init("get", FOLLOWINGS_URL + "?id=" + id);
	alert(FOLLOWINGS_URL + "?id=" + id);
	TwitterConsumer.SetOnReceive(People.OnGetFollowingSuccessful);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
People.OnGetFollowersSuccessful = function(httpRequest)
{
	alert("People.OnGetFollowerSuccessful()");
	Test(httpRequest, null, "httpRequest가 null");
	People.SetFollowersIdList(People.MakeIdList(httpRequest.responseXML));
	if(People.followers_return_func)
		People.followers_return_func();
}

People.GetFollowers = function(id, async)
{
	alert("People.GetFollower()");
	TwitterConsumer.Init("get", FOLLOWERS_URL + "?id=" + id);
	TwitterConsumer.SetOnReceive(People.OnGetFollowersSuccessful);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
People.SetGetFollowingAndFollowersSuccessfulFunc = function(func)
{
	this.following_followers_return_func = func;
}

People.OnGetFollowingAndFollowersSuccessful1 = function(httpRequest, id)
{
	alert("People.OnGetFollowingAndFollowersSuccessful1()");
	Test(httpRequest, null, "httpRequest가 null");
	People.SetFollowingIdList(People.MakeIdList(httpRequest.responseXML));
	
	TwitterConsumer.Init("get", FOLLOWERS_URL + "?id=" + id);
	TwitterConsumer.SetAdditionalInfo(id);
	TwitterConsumer.SetOnReceive(People.OnGetFollowingAndFollowersSuccessful2);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request();
}

People.OnGetFollowingAndFollowersSuccessful2 = function(httpRequest, id)
{
	alert("People.OnGetFollowingAndFollowersSuccessful2()");
	Test(httpRequest, null, "httpRequest가 null");
	People.SetFollowersIdList(People.MakeIdList(httpRequest.responseXML));
	
	if(People.following_followers_return_func)
		People.following_followers_return_func();
}

People.GetFollowingAndFollowersId = function(id)
{
	alert("People.GetFollowingAndFollowersId ()");
	TwitterConsumer.Init("get", FOLLOWINGS_URL + "?id=" + id);
	TwitterConsumer.SetAdditionalInfo(id);
	TwitterConsumer.SetOnReceive(People.OnGetFollowingAndFollowersSuccessful1);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request();
}
//////////////////////////////////////////////////////////////////////

People.SetGetUserReturnFunc = function(func)
{
	
}

People.GetUsernameList = function(id_list, update)
{
	var username_list = null;
	if (update == true || this.username_list==null) 
	{
		username_list = Array();
		var i;
		for (i = 0; i < id_list.length; i++) 
		{
			this.GetUser(id_list[i], false, username_list);
		}
	}
	else
	{
		username_list = this.username_list;
	}	
	
	this.username_list = username_list;
	
	return username_list;
}

People.GetUser = function(id,async,username_list)
{
	this.user_retrn_func = People.OnGetUserReturn;
	TwitterConsumer.Init("get", USER_SHOW_URL + "?id=" + id);
	TwitterConsumer.SetAdditionalInfo(username_list);	
	TwitterConsumer.SetOnReceive(People.OnGetUser);
	TwitterConsumer.Request(async);
}

People.GetRecipientIdList = function()
{
	var followers_list = People.GetFollowersIdList();
	var following_list = People.GetFollowingIdList();
	
	var i;
	var table = Array();
	var recipient_list = Array();
	for(i=0; i<followers_list.length; i++)
	{
		table[followers_list[i]] = true;
	}
	for(i=0; i<following_list.length; i++)
	{
		if (table[following_list[i]] == true) 
		{
			recipient_list[recipient_list.length] = following_list[i];
		}
	}
	
	return recipient_list;
}

///////////////////////////////////////////////////////////
People.OnGetUser = function(httpRequest, username_list)
{
	alert("People.OnGetUser()");
	
	var doc = httpRequest.responseXML;
	var response = doc.documentElement;
	var tmpItems = response.getElementsByTagName("screen_name");
	
	if(tmpItems.length > 0 && tmpItems[0].hasChildNodes())
	{	
		alert(username_list.length + " " +tmpItems[0].firstChild.data);
		username_list[username_list.length] = tmpItems[0].firstChild.data;		
	}
}


///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
People.SetGetFollowingUserReturnFunc = function(func)
{
	this.following_user_return_func = func;
}

People.OnGetFollowingUserSuccessful = function(httpRequest, cursor)
{
	alert("People.OnGetFollowingUserSuccessful()");
	
	var list = StatusUserMaker.MakeUserStatusList(httpRequest.responseXML);
	if(People.following_user_return_func)
		People.following_user_return_func(list, cursor);
}

People.GetFollowingUser = function(id, cursor, async)
{
	alert("People.GetFollowingUser()");
	
	alert(FRIENDS_GET_URL + id +".xml?cursor="+cursor);
	TwitterConsumer.Init("get", FRIENDS_GET_URL + id +".xml?cursor="+cursor);
	TwitterConsumer.SetAdditionalInfo(cursor);
	TwitterConsumer.SetOnReceive(People.OnGetFollowingUserSuccessful);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}

People.SetGetFollowersUserReturnFunc = function(func)
{
	this.followers_user_return_func = func;
}

People.OnGetFollowersUserSuccessful = function(httpRequest, cursor)
{
	alert("People.OnGetFollowersUserSuccessful()");
	
	var list = StatusUserMaker.MakeUserStatusList(httpRequest.responseXML);
	if(People.followers_user_return_func)
		People.followers_user_return_func(list, cursor);
}

People.GetFollowersUser = function(id, cursor, async)
{
	alert("People.GetFollowersUser()");
	
	alert(FRIENDS_GET_URL + id +".xml?cursor="+cursor);
	TwitterConsumer.Init("get", FOLLOWERS_GET_URL + id + ".xml?cursor=" + cursor);
	TwitterConsumer.SetAdditionalInfo(cursor);
	TwitterConsumer.SetOnReceive(People.OnGetFollowersUserSuccessful);
	TwitterConsumer.SetOnErrorReceive(Timeline.OnCriticalError);
	TwitterConsumer.Request(async);
}

///////////////////////////////////////////////////////////

People.GetFollowingTable = function()
{
	return this.following_table;
}

People.SetFollowingTableReturnFunc = function(func)
{
	this.following_table_return_func = func;
}

People.OnGetFollowerUserSuccessful = function(httpRequest, follower_index)
{
	alert("People.OnGetFollowerSuccessful() -> " + follower_index);
	
	if (People.GetFollowerCount() > follower_index) 
	{
		People.follower_table[follower_index] = UserMaker.MakeUser(httpRequest.responseXML);
		//People.following_loaded_count++;
		People.follower_temp_count++;
		
	}
	else 
	{
		for (var i = People.follower_temp_count; i < People.COUNT_IN_PAGE; i++) 
		{
			People.follower_table[i] = null;
			People.follower_temp_count++;
		}
	}
	
	if (People.follower_temp_count == People.COUNT_IN_PAGE) 
	{
		var list = Array();
		for (var i = 0; i < People.COUNT_IN_PAGE; i++) 
		{
			list[i] = People.follower_table[(People.follower_page_no - 1) * People.COUNT_IN_PAGE + i];
		}
		People.follower_temp_count = 0;
		People.follower_table_return_func(list);
	}
	else
		People.GetFollowerUser(People.follower_page_no);
}

People.GetFollowerTable = function()
{
	return this.follower_table;
}

People.SetFollowerTableReturnFunc = function(func)
{
	this.follower_table_return_func = func;
}

People.SetFollowersReturnFunc = function(func)
{
	this.followers_return_func = func;
}

People.MakeIdList = function(responseXML)
{
	var doc = responseXML;
	var response = doc.documentElement;
	var tmpItems = response.getElementsByTagName("id");
	var IdList = null;
	if(tmpItems.length > 0 && tmpItems[0].hasChildNodes())
	{	
		IdList = new Array();
		
		for (var i = 0; i < tmpItems.length; i++) 
		{
			IdList[i] = tmpItems[i].firstChild.data;
		}	
	}
	TWAlert("People.MakeIdList - " + IdList);
	return IdList;
}

People.GetRelationshipBetween = function(source_user, target_user)
{
	alert("People.GetRelationshipBetween() -> " + source_user + " " + target_user);
	TwitterConsumer.Init("get", USER_SHOW_URL + "?id=" + this.follower_id_list[index]);
	//alert(USER_SHOW_URL + "?id=" +
	//this.following_id_list[(page_no - 1) * this.PAGE_IN_COUNT + this.following_temp_count]);
	TwitterConsumer.SetAdditionalInfo(index);
	TwitterConsumer.SetOnReceive(People.OnGetFollowerUserSuccessful);
	TwitterConsumer.Request();
}

People.GetDirectMessagesUser = function()
{
	if (this.following_id_list instanceof Array && this.followers_id_list instanceof Array) {
		this.directmessages_user_id_list = new Array();
		
		var tmp_list = Array();
		
		var i;
		for (i = 0; i < this.following_id_list.length; i++) 
			tmp_list[this.following_id_list[i]] = true;
		for (i = 0; i < this.followers_id_list.length; i++) 
			if (tmp_list[this.followers_id_list[i]]) 
				this.directmessages_user_id_list[this.directmessages_user_id_list.length] = this.followers_id_list[i];
	} else {
		
	}
}

People.ContainDirectMessagesUser = function(id)
{
	alert("People.ContainDirectMessagesUser() -> " + id);
	for (var i = 0; i < this.directmessages_user_id_list.length; i++) 
	{
		alert(this.directmessages_user_id_list[i]);
		if (this.directmessages_user_id_list[i] == id) 
			return true;
	}
	return false;	
}