/**
 * Profile > Following or Followers에서 사용자를 얻기 위해 사용하는 클래스
 * @class Profile > Following or Followers에서 사용자를 얻기 위해 사용하는 클래스
 */
var ProfilePeople =
{
	following_id_list : null,
	following_return_func : null,
	following_table : Array(),
	
	followers_id_list : null,
	followers_return_func : null,
	followers_table : Array(),
	
	COUNT_IN_PAGE : 4
}
///////////////////////////////////////////////////////////////////////////////////

ProfilePeople.Reset = function()
{
	this.following_table = new Array();
	this.followers_table = new Array();
	this.following_id_list = null;
	this.followers_id_list = null;
}

///////////////////////////////////////////////////////////////////////////////////
ProfilePeople.GetFollowingIdList = function()
{
	return this.following_id_list;
}

ProfilePeople.GetFollowersIdList = function()
{
	return this.followers_id_list;	
}
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
ProfilePeople.ContainFollowingId = function(id)
{
	for(var i=0; i<this.following_id_list.length; i++)
		if(this.following_id_list[i] == id)
			return true;
	return false;
}

ProfilePeople.OnGetFollowingSuccessful = function(httpRequest)
{
	alert("ProfilePeople.OnGetFollowingSuccessful()");

	ProfilePeople.following_id_list = People.MakeIdList(httpRequest.responseXML);
	if(ProfilePeople.following_return_func)
		ProfilePeople.following_return_func();
}

People.SetFollowingReturnFunc = function(func)
{
	alert("People.SetFollowingReturnFunc()");
	this.following_return_func = func;
}

ProfilePeople.GetFollowing = function(id, async)
{
	alert("ProfilePeople.GetFollowing()");
	
	TwitterConsumer.Init("get", FOLLOWINGS_URL + "?id=" + id);
	TwitterConsumer.SetOnReceive(ProfilePeople.OnGetFollowingSuccessful);
	TwitterConsumer.Request(async);
}
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
ProfilePeople.OnGetFollowingUserSuccessful = function(httpRequest, following_index)
{
	alert("ProfilePeople.OnGetFollowingUserSuccessful() -> " + following_index);

	ProfilePeople.following_table[following_index] = 
									StatusUserMaker.MakeStatusUserListFromUser(httpRequest.responseXML);
}

ProfilePeople.GetFollowingUser = function(id, index, async)
{
	alert("ProfilePeople.GetFollowingUser()");

	TwitterConsumer.Init("get", USER_SHOW_URL + "?id=" + id);
	TwitterConsumer.SetAdditionalInfo(index);
	TwitterConsumer.SetOnReceive(ProfilePeople.OnGetFollowingUserSuccessful);
	TwitterConsumer.Request(async);
}

ProfilePeople.GetFollowingUserList = function(page_no, update)
{
	var i, c=0;
	var lowerbound = (page_no-1)*this.COUNT_IN_PAGE;
	var upperbound = (page_no-1)*this.COUNT_IN_PAGE + this.COUNT_IN_PAGE;
	
	alert("ProfilePeople.GetFollowingUserList() -> " + lowerbound + " " + upperbound);
	var current_following_list = null;
	for(i=lowerbound; i<this.following_id_list.length && i<upperbound; i++)
	{
		if(!current_following_list)
			current_following_list=new Array();
		
		if(!update && this.following_table[i])
		{
			current_following_list[c++] = this.following_table[i];
			continue;
		}
		
		if (this.following_id_list[i]) 
		{
			this.GetFollowingUser(this.following_id_list[i], i, false);
			current_following_list[c++] = this.following_table[i];
		}
	}	
	
	if(current_following_list)
		this.following_page_no = page_no;
	return current_following_list;
}
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
ProfilePeople.OnGetFollowersSuccessful = function(httpRequest)
{
	alert("ProfilePeople.OnGetFollowerSuccessful()");

	ProfilePeople.followers_id_list = People.MakeIdList(httpRequest.responseXML);
	if(ProfilePeople.followers_return_func)
		ProfilePeople.followers_return_func();
}

ProfilePeople.GetFollowers = function(id, async)
{
	alert("People.GetFollower()");
	TwitterConsumer.Init("get", FOLLOWERS_URL + "?id=" + id);
	TwitterConsumer.SetOnReceive(ProfilePeople.OnGetFollowersSuccessful);
	TwitterConsumer.Request(async);
}
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
ProfilePeople.OnGetFollowersUserSuccessful = function(httpRequest, followers_index)
{
	alert("ProfilePeople.OnGetFollowersUserSuccessful() -> " + followers_index);
	
	ProfilePeople.followers_table[followers_index] = 
									StatusUserMaker.MakeStatusUserListFromUser(httpRequest.responseXML);
}

ProfilePeople.GetFollowersUser = function(id, index, async)
{
	alert("ProfilePeople.GetFollowersUser()");

	TwitterConsumer.Init("get", USER_SHOW_URL + "?id=" + id);

	TwitterConsumer.SetAdditionalInfo(index);
	TwitterConsumer.SetOnReceive(ProfilePeople.OnGetFollowersUserSuccessful);
	TwitterConsumer.Request(async);
}

ProfilePeople.GetFollowersUserList = function(page_no, update)
{
	var i, c=0;
	var lowerbound = (page_no-1)*this.COUNT_IN_PAGE;
	var upperbound = (page_no-1)*this.COUNT_IN_PAGE + this.COUNT_IN_PAGE;
	
	alert("ProfilePeople.GetFollowersUserList() -> " + lowerbound + " " + upperbound);
	
	var current_followers_list = null;
	for(i=lowerbound; i<this.followers_id_list.length && i<upperbound; i++)
	{
		if(!current_followers_list)
			current_followers_list=new Array();
		
		if(!update && this.followers_table[i])
		{
			current_followers_list[c++] = this.followers_table[i];
			continue;
		}
		
		if (this.followers_id_list[i]) 
		{
			this.GetFollowersUser(this.followers_id_list[i], i, false);
			current_followers_list[c++]=this.followers_table[i];
		}
	}	
	
	if(current_followers_list)
		this.followers_page_no = page_no;
	return current_followers_list;
}
///////////////////////////////////////////////////////////////////////////////////