/**
 * Search 기능을 수행하는 클래스
 * @class Search 기능을 수행하는 클래스
 */
var Search = 
{
	search_return_func : null,
	next_page : null,
	ONCE_COUNT : 100
	
	, searchFailCallback : null
}

Search.SetSearchReturnFunc = function(func)
{
	this.search_return_func = func;
}

Search.setSearchFailByLimit = function(pFunc) {
	this.searchFailCallback = pFunc;
}

Search.OnSearch = function(httpRequest)
{
	alert("Search.OnSearch()");
	
	if (httpRequest.status == 420) {
		if(Search.searchFailCallback)
			Search.searchFailCallback(httpRequest.getResponseHeader('Retry-After'));
		return;
	}
	
	var temp_list = eval("(" + httpRequest.responseText +")");
	
	var objAdditional = {
		next_page : temp_list.next_page
		, page : temp_list.page
	}
	
	if(objAdditional.next_page == null)
	{
		if(Search.search_return_func)
			Search.search_return_func(null, objAdditional);
		return;
	}
	temp_list = temp_list.results;
	
	var search_list = new Array();
	for(var i=0; i<temp_list.length; i++)
	{
		var tmp_source = temp_list[i].source;
		temp_list.next_page
		tmp_source = tmp_source.replace(/&lt;/gi,"<");
		tmp_source = tmp_source.replace(/&quot;/gi,"\"");
		tmp_source = tmp_source.replace(/&gt;/gi,">");
		search_list[i] = new StatusUserData(new Date(Date.parse(temp_list[i].created_at)), temp_list[i].id, temp_list[i].text, tmp_source,
						 				    null, null, null, null, null, null, null, temp_list[i].from_user, null,
						   					null, temp_list[i].profile_image_url, null, null, null, null, null, null, null,
			  			   					null, null, null, null, null, null, null, null, null, null, null, null, null,
											null, null);
	}
	
	if(Search.search_return_func)
		Search.search_return_func(search_list, objAdditional);
}

Search.Search = function(query, next, async)
{
	alert("Search.Search() -> " + query);
	//encodeURIComponent
	alert(SEARCH_URL + "?q=" + escape(query) + "&rpp=" + this.ONCE_COUNT);
	alert(SEARCH_URL + this.next_page + "&rpp=" + this.ONCE_COUNT);
	
	if(next)
		TwitterConsumer.Init("get", SEARCH_URL + next);
	else
	{
		var is_sharp = false;
		for(var i=0; i<query.length; i++)
			if(query[i] == '#')
				is_sharp = true;
		if(is_sharp)
			TwitterConsumer.Init("get", SEARCH_URL + "?q=" + escape(query) + "&lang=en&rpp=" + this.ONCE_COUNT);
		else
			TwitterConsumer.Init("get", encodeURI(SEARCH_URL + "?q=" + query + "&lang=en&&rpp=" + this.ONCE_COUNT));
	}	
	TwitterConsumer.SetOnReceive(Search.OnSearch);
	TwitterConsumer.SetOn420Receive(Search.OnSearch);
	TwitterConsumer.Request(async);
}

//Find user information given user name 
// due to lack of information in search result
Search.fillUserInfo = {
	// Variable
	objStatus : null
	, fnListener : null
	
	// Method
	, get : function(pStatus, pListener) {
		TWAlert("Search.fillUserInfo.get : " + pStatus.ScreenName);
		
		Search.fillUserInfo.objStatus = pStatus;
		Search.fillUserInfo.fnListener = pListener;
		
		TwitterConsumer.Init("get", USER_SHOW_URL_JSON + "?screen_name=" + pStatus.ScreenName);
		TwitterConsumer.SetOnReceive(Search.fillUserInfo.callback);
		TwitterConsumer.Request();
	}
	, callback : function(pXHRObject) {
		TWAlert("Search.fillUserInfo.callback" );
		
		var objReturn = JSON.parse(pXHRObject.responseText);
		Search.fillUserInfo.objStatus.UserId = objReturn.id;
		Search.fillUserInfo.fnListener();
	}
}