/**
 * 다이렉트 메시지 작성, 답장 팝업을 구현한 클래스
 * @class 다이렉트 메시지 작성, 답장 팝업을 구현한 클래스
 */
var DirectMessageIME = 
{
	name_ime : null,
	text_ime : null,
	return_focus_object : null,
	focus_location : 0,
	current_index : 0,
	current_status : null,
	back_func : null,
	current_index : 0,
	username_list : null,
	name_key_anchor : null,
	mode : 1,
	user_name : null,
	
	name_input : null,
	text_input : null,
	KEYPAD_X : 600,
	KEYPAD_Y : 105,
	
	MAX_LENGTH : 140,
	
	COUNT_IN_MENUITEM : 5
}

/**
 * DirectMessageIME 초기화
 */
DirectMessageIME.Init = function()
{
	UIDirectMessageIME.Init();
	
	this.dropdownlist_key_anhor = document.getElementById("DirectMessagePopupKeyAnchor");
	this.name_key_anchor = document.getElementById("DirectMessageInputKeyAnchor");
	
	this.name_input = document.getElementById("DirectMessageIMEInputText1");
	this.text_input = document.getElementById("DirectMessageIMEInputText2");
	//this.SetReturnFocusFunc(object_name);

	//UIDirectMessageIME.ShowTextboxHighlight();
	if(!this.name_ime)
		this.name_ime = new IMEShell("DirectMessageIMEInputText1", DirectMessageIME.InitCallback_Name);
	if(!this.text_ime)
		this.text_ime = new IMEShell("DirectMessageIMEInputText2", DirectMessageIME.InitCallback_Text);	
//	KeyHandler.FocusNoKey();
}

/**
 * 현재 모드를 얻음
 * @return {Number} 현재 모드 값, 0,100,101,3:DirectMessages, 1:Home, 2:People, 4:Profile, 5:ProfilePeople, 102:DirectMessageDetailView
 */
DirectMessageIME.GetMode = function()
{
	return this.mode;	
}

/**
 * 현재 선택된 사용자 이름 얻음
 * @return {String} 현재 선택된 사용자 이름
 */
DirectMessageIME.GetCurrentUsername = function()
{
	//for(var i=0;i<this.username_list.length;i++)
	//	alert(this.username_list[i]);
	return this.username_list[this.current_index];
}

/**
 * 키패드를 닫았을 때 되돌아 갈 포커스 함수 지정 
 * @param {Object} object_name 포커스 함수
 */
DirectMessageIME.SetReturnFocusFunc = function(object_name)
{
	this.return_focus_object = object_name;
}

/**
 * 이름 입력 Input Box에 포커스 지정
 */
DirectMessageIME.FocusInputText1 = function()
{
	this.name_input.focus();	
}

/**
 * 텍스트 입력 Input Box에 포커스 지정
 */

DirectMessageIME.FocusInputText2 = function()
{
	alert("DirectMessageIME.FocusInputText2()");
	this.text_input.focus();	
}

/**
 * Show 함수에서 호출하는 메소드, Show함수의 초기 구성을 한다.
 */
DirectMessageIME.ShowSub = function()
{
	alert("DirectMessageIME.ShowSub()");
	
	UIDirectMessageIME.SetRemain(this.MAX_LENGTH);
	if(this.mode != 0)
	{
		alert(this.user_id);
		
		if(People.ContainFollowersId(this.user_id))
		{
			//this.name_input.value = this.user_name;
			this.name_ime.setString(typeof(this.user_name) == "string" ? this.user_name.toHTML() : this.user_name);
			DirectMessageIME.text_ime.setString("");
			UIDirectMessageIME.UpdatePreview("");			
			UIDirectMessageIME.ShowTextboxHighlight();
			DirectMessageIME.text_input.focus();
		}	
		else
		{
       		
			//interactive remote start
			iRemoteTW.messgPopup("", SID_YOU_CAN_SEND_DIRECT_MESSAGES_ONLY_TO_YOUR_FOLLOWERS); 
			//interactive remote end
			
			MessageBoxMgr.Show("", SID_YOU_CAN_SEND_DIRECT_MESSAGES_ONLY_TO_YOUR_FOLLOWERS,
						   function()
						   {
								DirectMessageIME.Hide();
								
								if(DirectMessageIME.mode == 0 || DirectMessageIME.mode == 100 || DirectMessageIME.mode == 101)
								{
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
								}
								else if (DirectMessageIME.mode == 1)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									
									HomeMgr.Refresh();
									HomeMgr.Focus();

									//interactive remote start
									iRemoteTW.home();
									//interactive remote end
                                }
								else if(DirectMessageIME.mode == 2)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									
									PeopleMgr.Refresh();
									PeopleMgr.Focus();

									//interactive remote start
									iRemoteTW.people();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 3)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();

									//interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 4)
								{
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();

									//interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 5)
								{
									ProfilePeopleMgr.Refresh();
									ProfilePeopleMgr.Focus();
									
									//interactive remote start
                                     					if(ProfilePeopleMgr.mode == 1){

										iRemoteTW.profilePeopleFollowing();
                                                			}
                                            				else if(ProfilePeopleMgr.mode == 2){

										iRemoteTW.profilePeopleFollowers();
                                                			}
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 102)
								{
									DirectMessageDetailViewMgr.Refresh();
									DirectMessageDetailViewMgr.Focus();
									
									//interactive remote start
									iRemoteTW.directMessgDetailView();
									//interactive remote end
                                    
								}  	
						   });
			return;
		}
	}
	else
	{
		DirectMessageIME.name_ime.setString("");
		DirectMessageIME.text_ime.setString("");
		UIDirectMessageIME.UpdatePreview("");
		
		this.FocusInputText1();		
		UIDirectMessageIME.HideTextboxHighlight();
	}
	
	
	UIDirectMessageIME.Show();
	HelpNavigationMgr.ShowDirectMessageIMEHelp();
}

/**
 * 다이렉트 메시지 작성, 답장 팝업을 화면에 보이는 함수
 * @param {Object} status Status 데이터
 * @param {Function} back_func 팝업이 닫힌 후에 실행할 함수
 * @param {String} user_name 사용자 이름
 * @param {Number} mode 모드값
 * @param {String} user_id 사용자 번호
 */
DirectMessageIME.Show = function(status, back_func, user_name, mode, user_id)
{
	alert("DirectMessageIME.Show()");
	this.user_id = user_id;
	this.mode = mode;
	this.back_func = back_func;
	this.current_status = status;
	this.user_name = user_name;
	//setTimeout("DirectMessageIME.ShowSub()", 0);
	//this.text_input.value = "";
	DirectMessageIME.ShowSub();
}

/**
 * 이름 입력 IME에 대한 초기화 함수
 * @param {Object} text_imeobj IME문서 참조
 */
DirectMessageIME.InitCallback_Name = function(text_imeobj)
{	
	var inputobj = text_imeobj.getInputObj();
	
	alert("start initializing : "+text_imeobj.id);
	
	text_imeobj.setKeypadPos(DirectMessageIME.KEYPAD_X, DirectMessageIME.KEYPAD_Y);
	
	Util.T9WordBoxPos(text_imeobj);

	//text_imeobj.setOnCompleteFunc(DirectMessageIME.OnComplete_Text);
	text_imeobj.setEnterFunc(DirectMessageIME.OnEnter_Name);
	text_imeobj.setKeyFunc(tvKey.KEY_RETURN, DirectMessageIME.OnReturn_Name);
	//text_imeobj.setKeyFunc(tvKey.KEY_RETURN, DirectMessageIME.OnReturn_Text);
	//text_imeobj.setKeyFunc(tvKey.KEY_DOWN, DirectMessageIME.OnDown_Text);
	//text_imeobj.setKeyFunc(tvKey.KEY_BLUE, DirectMessageIME.OnBlue_Text);
	//text_imeobj.setKeyFunc(tvKey.KEY_YELLOW, DirectMessageIME.OnYellow_Text);
	
	//DirectMessageIME.text_input.style.display = DISPLAY_BLOCK;
	alert("name_ime_init end...");
}

/**
 * 텍스트(다이렉트 메시지 내용) 입력 IME에 대한 초기화 함수
 * @param {Object} text_imeobj IME문서 참조
 */
DirectMessageIME.InitCallback_Text = function(text_imeobj)
{	
	var inputobj = text_imeobj.getInputObj();
	
	alert("start initializing : "+text_imeobj.id);
	
	text_imeobj.setKeypadPos(DirectMessageIME.KEYPAD_X, DirectMessageIME.KEYPAD_Y);

	Util.T9WordBoxPos(text_imeobj);	

	//text_imeobj.setOnCompleteFunc(DirectMessageIME.OnComplete_Text);
	text_imeobj.setEnterFunc(DirectMessageIME.OnEnter_Text);
	text_imeobj.setKeyFunc(tvKey.KEY_RETURN, DirectMessageIME.OnReturn_Text);
	//text_imeobj.setKeyFunc(tvKey.KEY_DOWN, DirectMessageIME.OnDown_Text);
	//text_imeobj.setKeyFunc(tvKey.KEY_BLUE, DirectMessageIME.OnBlue_Text);
	text_imeobj.setKeyFunc(tvKey.KEY_YELLOW, DirectMessageIME.OnYellow_Text);
	text_imeobj.setAnyKeyFunc(DirectMessageIME.OnAnyKey_Text);
	
	//DirectMessageIME.text_input.style.display = DISPLAY_BLOCK;
	alert("name_ime_init end...");
}

/**
 * 이름 입력 Input Box에서 확인 버튼을 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnEnter_Name = function()
{
	alert("DirectMessageIME.EnterName()");
	var name = DirectMessageIME.name_input.value;
	
	if(name=="")
	{
		UIDirectMessageIME.Hide();
		//interactive remote start
		iRemoteTW.messgPopup("", TEMPID_NAME_INPUT_ERROR_MSG); 
		//interactive remote end
		MessageBoxMgr.Show("", TEMPID_NAME_INPUT_ERROR_MSG,
						   function()
						   {
						   		UIDirectMessageIME.Show();
								DirectMessageIME.FocusInputText1();		   	
						   });
	}
	else 
	{
		DirectMessageIME.user_name=DirectMessageIME.name_input.value;
		UIDirectMessageIME.ShowTextboxHighlight();
		DirectMessageIME.text_input.focus();
	}
	/*
	if (name == "") 
	{
		UIDirectMessageIME.ShowDropdownList();
		UIDirectMessageIME.Refresh();
		DirectMessageIME.FocusDropdownList();
	}
	else 
	{
		UIDirectMessageIME.ShowTextboxHighlight();
		DirectMessageIME.text_input.focus();
	}
	*/
}

/**
 * 이름 입력 Input Box에서 리턴 버튼을 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnReturn_Name = function()
{
	alert("DirectMessageIME.OnReturn_Name()");
	
	UIDirectMessageIME.Hide();
    //interactive remote start
	iRemoteTW.dirmssgIMEcancel();
	//interactive remote end
	YesNoPopupMgr.Show(function(return_code)
						{
							alert("return_code -> " + return_code);
							if(return_code == 0)
							{
								DirectMessageIME.Hide();
			
								if(DirectMessageIME.mode == 0 || DirectMessageIME.mode == 100 || DirectMessageIME.mode == 101)
								{
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
								}
								else if (DirectMessageIME.mode == 1)
								{
                                
                                    //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                    
									HomeMgr.Refresh();
									HomeMgr.Focus();
                                    
                                     //interactive remote start
									iRemoteTW.home();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 2)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                    
									HelpNavigationMgr.ShowPeopleHelp(PeopleMgr.GetMode());
									PeopleMgr.Refresh();
									PeopleMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.people();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 3)
								{
                                         //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                    
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 4)
								{
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();
                                    
                                    //interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 5)
								{
									ProfilePeopleMgr.Refresh();
									ProfilePeopleMgr.Focus();
                                    
                                    //interactive remote start
                                     					if(ProfilePeopleMgr.mode == 1){

										iRemoteTW.profilePeopleFollowing();
                                                			}
                                            				else if(ProfilePeopleMgr.mode == 2){

										iRemoteTW.profilePeopleFollowers();
                                                			}
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 102)
								{
									DirectMessageDetailViewMgr.Refresh();
									DirectMessageDetailViewMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.directMessgDetailView();
									//interactive remote end
								}  	
							}
							else
							{
								UIDirectMessageIME.Show();
								DirectMessageIME.FocusInputText1();	
							}
						});
}

/**
 * 텍스트 입력 Input Box에서 아무키나 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnAnyKey_Text = function()
{
	alert("DirectMessageIME.OnComplete_Text()");
	var text = document.getElementById("DirectMessageIMEInputText2").value;
	UIDirectMessageIME.UpdatePreview(text.toSeperate());
	UIDirectMessageIME.SetRemain(DirectMessageIME.MAX_LENGTH-text.length);
	//UIDirectMessageIME.Refresh();
}

/**
 * 텍스트 입력 Input Box에서 옐로우 버튼을 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnYellow_Text = function()
{
	var text = DirectMessageIME.text_input.value;
	
	DirectMessageIME.text_ime.setString("");
}
/*
DirectMessageIME.OnBlue_Text = function()
{
	alert("DirectMessageIME.OnBlue()");
	
}

DirectMessageIME.OnDown_Text = function()
{
	widgetAPI.blockNavigation(event);
}
*/

/**
 * 다이렉트 메시지 보내기 성공 후 실행되는 콜백 함수
 */
DirectMessageIME.OnSendDirectMessageSuccessful = function()
{
	alert("DirectMessageIME.OnSendDirectMessageSuccessful()");
	alert("다이렉트 메시지 보내기 성공성공");
	
	LoadingMgr.Hide();
	
	DirectMessagesMgr.SetUpdate(2);
	//interactive remote start
	iRemoteTW.messgPopup("", SID_MESSAGE_SENT_SUCCESSFULLY); 
	//interactive remote end
	MessageBoxMgr.Show("", SID_MESSAGE_SENT_SUCCESSFULLY,
						   function()
						   {
								DirectMessageIME.back_func();
						   });
}

/**
 * 다이렉트 메시지 보내기 실패 후 실행되는 콜백 함수
 */
DirectMessageIME.OnSendDirectMessageError = function(httpRequest)
{
	alert("DirectMessageIME.OnSendDirectMessageError()");

	LoadingMgr.Hide();

	var strErrorMsg = "";
	var nErrorCode = parseInt(httpRequest.status,10);
	if (nErrorCode == 404 || nErrorCode == 403) {
		strErrorMsg = SID_YOU_CAN_SEND_DIRECT_MESSAGES_ONLY_TO_YOUR_FOLLOWERS;
	} else {
		strErrorMsg = SID_ALERT_NETWORKERROR_MSG;
	}
	//interactive remote start
	iRemoteTW.messgPopup("", strErrorMsg); 
	//interactive remote end
	MessageBoxMgr.Show("", strErrorMsg,
						   function()
						   {
								if(DirectMessageIME.mode == 0 || DirectMessageIME.mode == 100 || DirectMessageIME.mode == 101)
								{
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
								}
								else if (DirectMessageIME.mode == 1)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                    
									HomeMgr.Refresh();
									HomeMgr.Focus();
                                    
                                     //interactive remote start
									iRemoteTW.home();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 2)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                    
									HelpNavigationMgr.ShowPeopleHelp(PeopleMgr.GetMode());
									PeopleMgr.Refresh();
									PeopleMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.people();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 3)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
                                
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 4)
								{
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();
                                    
                                    //interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 5)
								{
									ProfilePeopleMgr.Refresh();
									ProfilePeopleMgr.Focus();
                                    
                                    //interactive remote start
                                     					if(ProfilePeopleMgr.mode == 1){

										iRemoteTW.profilePeopleFollowing();
                                                			}
                                            				else if(ProfilePeopleMgr.mode == 2){

										iRemoteTW.profilePeopleFollowers();
                                                			}
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 102)
								{
									DirectMessageDetailViewMgr.Refresh();
									DirectMessageDetailViewMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.directMessgDetailView();
									//interactive remote end
								}  						   	
						   });
	
}

/**
 * 텍스트 입력 Input Box에서 엔터키를 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnEnter_Text = function()
{
	var text = DirectMessageIME.text_input.value;
	if (text.replace(/ /gi,'') == "") //아무것도 입력 안 했을 시 
	{
		UIDirectMessageIME.Hide();
		//interactive remote start
		iRemoteTW.messgPopup("", SID_PLEASE_ENTER_A_MESSAGE); 
		//interactive remote end
		MessageBoxMgr.Show("", SID_PLEASE_ENTER_A_MESSAGE, 
						   function()
						   {
						   		UIDirectMessageIME.Show();
								DirectMessageIME.FocusInputText2();
						   });
	}
	else if (this.MAX_LENGTH - text.length < 0) 
	{
		UIDirectMessageIME.Hide();
		//interactive remote start
		iRemoteTW.messgPopup("",SID_MIX_MESSAGES_MOT_EXCEED_A_CHARACTERS.Replace("140")); 
		//interactive remote end
		MessageBoxMgr.Show("", SID_MIX_MESSAGES_MOT_EXCEED_A_CHARACTERS.Replace("140"), function()
		{
			UIDirectMessageIME.Show();
			DirectMessageIME.Focus();
		});
	}
	else 
	{
		DirectMessageIME.Hide();
		KeyHandler.FocusNoKey();
		LoadingMgr.Show();
		DirectMessages.SetSendDirectMessageReturnFunc(DirectMessageIME.OnSendDirectMessageSuccessful);
		DirectMessages.SetSendDirectMessageErrorFunc(DirectMessageIME.OnSendDirectMessageError);
		//DirectMessages.SendDirectMessage(DirectMessageIME.name_input.value, text);
		DirectMessages.SendDirectMessage(DirectMessageIME.user_name, text);
	}
}

/**
 * 텍스트 입력 Input Box에서 리턴키를 눌렀을 때 실행되는 함수
 */
DirectMessageIME.OnReturn_Text = function()
{
	alert("DirectMessageIME.OnReturn");
	UIDirectMessageIME.Hide();

	//interactive remote start
	iRemoteTW.dirmssgIMEcancel();
	//interactive remote end
	YesNoPopupMgr.Show(function(return_code)
						{
							alert("return_code -> " + return_code);
							if(return_code == 0)
							{
								DirectMessageIME.Hide();
			
								if(DirectMessageIME.mode == 0 || DirectMessageIME.mode == 100 || DirectMessageIME.mode == 101)
								{
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();

									//interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end
								}
								else if (DirectMessageIME.mode == 1)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									HomeMgr.Refresh();
									HomeMgr.Focus();

								   //interactive remote start
									iRemoteTW.home();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 2)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									HelpNavigationMgr.ShowPeopleHelp(PeopleMgr.GetMode());
									PeopleMgr.Refresh();
									PeopleMgr.Focus();

									//interactive remote start
									iRemoteTW.people();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 3)
								{

									//interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
									//interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end

								}
								else if(DirectMessageIME.mode == 4)
								{
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();

									//interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 5)
								{
									ProfilePeopleMgr.Refresh();
									ProfilePeopleMgr.Focus();
									//interactive remote start
                                            				if(ProfilePeopleMgr.mode == 1){

												iRemoteTW.profilePeopleFollowing();
                                                			}
                                           				 else if(ProfilePeopleMgr.mode == 2){

												iRemoteTW.profilePeopleFollowers();
                                                			}
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 102)
								{
									DirectMessageDetailViewMgr.Refresh();
									DirectMessageDetailViewMgr.Focus();
                                    					//interactive remote start
									iRemoteTW.directMessgDetailView();
									//interactive remote end
								}  	
							}
							else
							{
								UIDirectMessageIME.Show();
								DirectMessageIME.FocusInputText2();	
							}
						});
}

/**
 * 다이렉트 메시지 보내기, 답장 팝업 닫기
 */
DirectMessageIME.Hide = function()
{
	if(DirectMessageIME.return_focus_object)
		DirectMessageIME.return_focus_object.focus();
	UIDirectMessageIME.Hide();
	HelpNavigationMgr.HideDirectMessageIMEHelp();
}

/**
 * 다이렉트 메시지 보내기, 답장 팝업의 키 핸들러
 */
DirectMessageIME.KeyHandler = function()
{
	alert("DirectMessageIME.KeyHandler() -> " + event.keyCode);
	if (!CUtil.delayKey()) return;
	switch (event.keyCode)
	{
		case tvKey.KEY_UP:
			this.MoveUpDropdownList();
			UIDirectMessageIME.Refresh();
			break;
		case tvKey.KEY_DOWN:
			this.MoveDownDropdownList();
			UIDirectMessageIME.Refresh();
			break;
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			UIDirectMessageIME.HideDropdownList();
			this.FocusInputText1();
			break;
		case tvKey.KEY_ENTER:
			DirectMessageIME.name_input.value = this.GetCurrentUsername();
			UIDirectMessageIME.HideDropdownList();
			UIDirectMessageIME.ShowTextboxHighlight();
			this.FocusInputText2();
			break;
	}	
}

DirectMessageIME.InputKeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("DirectMessageIME.InputKeyHandler() -> " + event.keyCode);
	switch (event.keyCode)
	{
		case tvKey.KEY_UP:
			break;
		case tvKey.KEY_DOWN:
			break;
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			
			YesNoPopupMgr.Show(function(return_code)
						{
							alert("return_code -> " + return_code);
							if(return_code == 0)
							{
								DirectMessageIME.Hide();
			
								if(DirectMessageIME.mode == 0 || DirectMessageIME.mode == 100 || DirectMessageIME.mode == 101)
								{
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
								}
								else if (DirectMessageIME.mode == 1)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									HomeMgr.Refresh();
									HomeMgr.Focus();
                                    
                                     //interactive remote start
									iRemoteTW.home();
									//interactive remote end
                                    
								}
								else if(DirectMessageIME.mode == 2)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									HelpNavigationMgr.ShowPeopleHelp(PeopleMgr.GetMode());
									PeopleMgr.Refresh();
									PeopleMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.people();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 3)
								{
                                     //interactive remote start
									iRemoteTW.onLoad();
									//interactive remote end
									DirectMessagesMgr.Refresh();
									DirectMessagesMgr.Focus();
                                    
                                    //interactive remote start
									iRemoteTW.directMessage();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 4)
								{
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();
                                    
                                    //interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								}
								else if(DirectMessageIME.mode == 5)
								{
									ProfilePeopleMgr.Refresh();
									ProfilePeopleMgr.Focus();
                                    
                                    //interactive remote start
                                     					if(ProfilePeopleMgr.mode == 1){

										iRemoteTW.profilePeopleFollowing();
                                                			}
                                            				else if(ProfilePeopleMgr.mode == 2){

										iRemoteTW.profilePeopleFollowers();
                                                			}
									//interactive remote end
								}
							}
							else
							{
								DirectMessageIME.FocusInputText1();	
							}
						});
						
			
			break;
		case tvKey.KEY_ENTER:
			//this.EnterName();
			break;
	}
}
