/**
 * Home 카테고리의 정렬 기능을 구현한 클래스
 * @class Home 카테고리의 정렬 기능을 구현한 클래스
 */
var FilteringMgr = 
{
	current_index : 0,
	key_anchor : null,
	
	ITEMS_IN_PAGE : 3
}

/**
 * FilteringMgr 초기화
 */
FilteringMgr.Init = function()
{
	this.key_anchor = document.getElementById("FilteringKeyAnchor");
	UIFiltering.Init();
}

/**
 * 현재 모드를 지정하는 함수
 * @param {Number} mode 0:All, 1:@Username, 2:Favorites
 */
FilteringMgr.SetMode = function()
{
	this.current_index = HomeMgr.GetMode();
}

/**
 * 현재 선택되고 있는 인덱스를 가져오는 함수
 */
FilteringMgr.GetCurrentIndex = function()
{
	return this.current_index;
}

/**
 * 정렬 기능 팝업의 내용을 그리는 함수
 */
FilteringMgr.Display = function()
{
	UIFiltering.Display();
}

/**
 * 정렬 기능 팝업을 화면에 표시하는 함수
 */
FilteringMgr.Show = function()
{
	FilteringMgr.SetMode();
	
	this.Display();
	UIFiltering.Show();
	this.Focus();
}

/**
 * 정렬 기능 팝업을 닫는 함수
 */
FilteringMgr.Hide = function()
{
	UIFiltering.Hide();
}

/**
 * 정렬 기능 팝업에 키입력 포커스를 주는 함수
 */
FilteringMgr.Focus = function()
{
	this.key_anchor.focus();
}

/**
 * 포커스를 왼쪽으로 이동하는 함수
 */
FilteringMgr.MoveLeft = function()
{
	alert("FilteringMgr.MoveLeft()");
	this.current_index--;
	if(this.current_index<0)
		this.current_index = this.ITEMS_IN_PAGE -1;
	this.Display();
}

/**
 * 포커스를 오른쪽으로 이동하는 함수
 */
FilteringMgr.MoveRight = function()
{
	alert("FilteringMgr.MoveRight()");
	this.current_index++;
	if(this.current_index>=this.ITEMS_IN_PAGE)
		this.current_index = 0;
	this.Display();
}

/**
 * 해당 기능을 선택했을 때 기능을 수행하는 함수
 */
FilteringMgr.Select = function()
{
	if(HomeMgr.GetList(this.current_index) != null)
	{
		HomeMgr.SetMode(this.current_index);
		HomeMgr.Show();
		HomeMgr.Focus();
		return;
	}
	LoadingMgr.Show();
	KeyHandler.FocusNoKey();
	switch(this.current_index)
	{
		case TwitterDefine.Mode.ALL :
			break;
		case TwitterDefine.Mode.USERNAME :
			Timeline.SetGetMentionsReturnFunc(HomeMgr.OnMentionListReturn);
			Timeline.GetMentions(1);
			break;
		case TwitterDefine.Mode.FAVORITE :
			Favorites.SetFavoritesListReturnFunc(HomeMgr.OnFavoriteListReturn);
			Favorites.GetFavoritesList(ID,1);
			break;
	}
}

/**
 * 정렬기능 팝업의 키핸들러
 */
FilteringMgr.KeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("FilteringMgr.KeyHandler -> KeyCode : " + event.keyCode);
	switch (event.keyCode)
	{
		case tvKey.KEY_LEFT:
			this.MoveLeft();
			break;
		case tvKey.KEY_RIGHT:
			this.MoveRight();
			break;
		case tvKey.KEY_ENTER:
			this.Select();
			this.Hide();
			break;
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			this.Hide();
			UIHelpNavigation.Refresh();
			HomeMgr.Focus();
			break;
	}
}