/**
 * Help Navigation을 관할하는 클래스
 * @class Help Navigation을 관할하는 클래스
 */
var HelpNavigationMgr = 
{
	
}

/**
 * HelpNavigationMgr 초기화
 */
HelpNavigationMgr.Init = function()
{
	UIHelpNavigation.Init();
}

/**
 * Home 카테고리의 Help Navigation 표시하는 함수 
 * @param {Number} mode 1:자산의 글에 하이라이트 위치, 2:자신의 글이 아닌 곳에 하이라이트 위치 
 * @param {Number} favorite 1 : unfavorite 글에 하이라이트 위치, 2 : favorite 글에 하이라이트 위치
 */
HelpNavigationMgr.ShowHomeHelp = function(mode, favorite)
{
	alert("HelpNavigationMgr.ShowHomeHelp()");
	UIHelpNavigation.ShowHomeHelp(mode, favorite);
}

/**
 * Tweet 글 상세보기 팝업의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowDetailViewHelp = function()
{
	alert("HelpNavigationMgr.ShowDetailViewHelp()");
	UIHelpNavigation.ShowDetailViewHelp();
}

/**
 * Reply 팝업의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowReplyHelp = function()
{
	alert("HelpNavigationMgr.ShowDetailViewHelp()");
	UIHelpNavigation.ShowReplyHelp();
}

/**
 * Home 카테고리의 새글작성 팝업의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowWritingHelp = function()
{
	alert("HelpNavigationMgr.ShowWritingHelp()");
	UIHelpNavigation.ShowWritingHelp();
}

/**
 * Home 카테고리의 새글작성 팝업의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowMultilineHelp = function()
{
	alert("HelpNavigationMgr.ShowMultilineHelp()");
	UIHelpNavigation.ShowMultilineHelp();
}

/**
 * Home 카테고리의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideHomeHelp = function()
{
	alert("HelpNavigationMgr.HideHomeHelp()");
	UIHelpNavigation.HideHomeHelp();
}

/**
 * People 카테고리의 Help Navigation 표시하는 함수
 * @param {Number} mode 1:Following일때, 2:Followers일때
 */
HelpNavigationMgr.ShowPeopleHelp = function(mode)
{
	alert("HelpNavigationMgr.ShowPeopleHelp() -> " + mode);
	UIHelpNavigation.ShowPeopleHelp(mode);
}

/**
 * People 카테고리의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HidePeopleHelp = function()
{
	alert("HelpNavigationMgr.HidePeopleHelp()");
	UIHelpNavigation.HidePeopleHelp();
}

/**
 * ProfilePeople 페이지의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowProfilePeopleHelp = function(pMode)
{
	alert("HelpNavigationMgr.ShowProfilePeopleHelp()");
	UIHelpNavigation.ShowProfilePeopleHelp(pMode);
}

/**
 * ProfilePeople 페이지의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideProfilePeopleHelp = function()
{
	alert("HelpNavigationMgr.HideProfilePeopleHelp()");
	UIHelpNavigation.HideProfilePeopleHelp();
}

/**
 * Messages 카테고리의 Help Navigation 표시하는 함수
 * @param {Number} mode 100:inbox, 101:sent
 */
HelpNavigationMgr.ShowDirectMessagesHelp = function(mode)
{
	alert("HelpNavigationMgr.ShowDirectMessagesHelp() -> " + mode);
	UIHelpNavigation.ShowDirectMessagesHelp(mode);
}

/**
 * Messages 카테고리에서 목록이 하나도 없을때의 Help Navigation 표시하는 함수
 * @param {Number} mode 100:inbox, 101:sent
 */
HelpNavigationMgr.ShowDirectMessagesNoListHelp = function(mode)
{
	alert("HelpNavigationMgr.ShowDirectMessagesNoListHelp() -> " + mode);
	UIHelpNavigation.ShowDirectMessagesNoListHelp(mode);
}

/**
 * Messages 카테고리의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideDirectMessagesHelp = function()
{
	alert("HelpNavigationMgr.HideDirectMessagesHelp()");
	UIHelpNavigation.HideDirectMessagesHelp();
}

/**
 * Profile 페이지의 Help Navigation 표시하는 함수
 * @param {Object} mode 1:Unfavorite일때 2:Favorite일때
 */
HelpNavigationMgr.ShowProfileHelp = function(pMode)
{
	alert("HelpNavigationMgr.ShowProfileHelp()");
	UIHelpNavigation.ShowProfileHelp(pMode);
}

/**
 * Profile 페이지의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideProfileHelp = function()
{
	UIHelpNavigation.HideProfileHelp();
}

/**
 * Profile 페이지의 Help Navigation 표시하는 함수
 * @param {Object} mode 1:Unfavorite일때 2:Favorite일때
 */
HelpNavigationMgr.ShowProfileLeftHelp = function(pMode)
{
	alert("HelpNavigationMgr.ShowProfileLeftHelp()");
	UIHelpNavigation.ShowProfileLeftHelp(pMode);
}

/**
 * Profile 페이지의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideProfileHelp = function()
{
	UIHelpNavigation.HideProfileHelp();
}

/**
 * DirectMessage IME 팝업의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowDirectMessageIMEHelp = function()
{
	UIHelpNavigation.ShowDirectMessageIMEHelp();	
}

/**
 * DirectMessage IME 팝업의 Help Navigation을 숨기는 함수
 */
HelpNavigationMgr.HideDirectMessageIMEHelp = function()
{
	UIHelpNavigation.HideDirectMessageIMEHelp();	
}

/**
 * Topics 카테고리의 Help Navigation 표시하는 함수
 */
HelpNavigationMgr.ShowTopicsHelp = function()
{
	UIHelpNavigation.ShowTopicsHelp();	
}

/**
 * Topics 카테고리의 Help Navigation 숨기는 함수
 */
HelpNavigationMgr.HideTopicsHelp = function()
{
	UIHelpNavigation.HideTopicsHelp();	
}

/**
 * More 카테고리의 Help Navigation 표시하는 함수
 * @param {Number} mode 1:Unfavorite일때, 2:Favorite일때
 */
HelpNavigationMgr.ShowMoreHelp = function(mode)
{
	UIHelpNavigation.ShowMoreHelp(mode);	
}

/**
 * More 카테고리의 Help Navigation 숨기는 함수
 */
HelpNavigationMgr.HideMoreHelp = function()
{
	alert("HelpNavigationMgr.HideMoreHelp()");
	UIHelpNavigation.HideMoreHelp();	
}

/**
 * Search 페이지의 Help Navigation 표시하는 함수
 * @param {Number} mode 현재 사용하지 않음.
 */
HelpNavigationMgr.ShowSearchHelp = function(mode)
{
	alert("HelpNavigationMgr.ShowSearchHelp() -> " + mode);
	UIHelpNavigation.ShowSearchHelp(mode);	
}

/**
 * Search 페이지의 Help Navigation 숨기는 함수
 */
HelpNavigationMgr.HideSearchHelp = function()
{
	UIHelpNavigation.HideSearchHelp();	
}