/**
 * 로딩중 팝업을 구현한 클래스
 * @class 로딩중 팝업을 구현한 클래스
 */
var LoadingMgr =
{
	timer : null,
	current_index : 0,
	
	IMAGE_MAX_COUNT : 12,
	TIMER_INTERVAL : 500,
	SCREEN_WIDTH : 960,
	SCRREN_HEIGHT : 540,
	
	LOADING_WIDTH : 154,
	LOADING_HEIGHT : 143,
	
	EXTRA_LEFT :  40
}

/**
 * LoadingMgr 초기화
 */
LoadingMgr.Init = function()
{
	alert("LoadingMgr.Init()");
	UILoading.Init();
}

/**
 * 로딩 이미지를 한장씩 바꿔주는 함수
 * Timer에 의해 호출된다.
 */
LoadingMgr.Animte = function()
{
	this.current_index++;
	if(this.current_index >= this.IMAGE_MAX_COUNT)
		this.current_index = 0;
	
	UILoading.SetLoadingImage(this.current_index);
	
	//this.timer = setInterval("LoadingMgr.Animte()", this.TIMER_INTERVAL);
}

/**
 * 로딩중 팝업을 화면에 표시하는 함수
 * @param {Number} x 표시할 X좌표, 생략가능, 생략하면 디폴트값
 * @param {Number} y 표시할 Y좌표, 생략가능, 생략하면 디폴트값
 */
LoadingMgr.Show = function(x, y)
{
	if(x==null)
		x = ( this.SCREEN_WIDTH - this.LOADING_WIDTH ) / 2;
	if(y==null)
		y = ( this.SCRREN_HEIGHT - this.LOADING_HEIGHT ) / 2;

	if (this.timer) 
	{
		clearInterval(this.timer);
		this.timer = null;
	}
	this.timer = setInterval("LoadingMgr.Animte()", this.TIMER_INTERVAL);	
		//this.timer = setTimeout("LoadingMgr.Animte()", this.TIMER_INTERVAL);
	
	UILoading.Show(x, y);
	//interactive remote start
	iRemoteTW.showLoading();
	//interactive remote end
}

/**
 * 로딩중 팝업을 화면에서 숨긴다.
 */
LoadingMgr.Hide = function()
{
	if (this.timer) 
	{
		clearInterval(this.timer);
		this.timer = null;
	}
	UILoading.Hide();
	//interactive remote start
	iRemoteTW.hideLoading();
	//interactive remote end
}
