/**
 * 화면 상단부 메인 카테고리를 관할하는 클래스
 * @class 화면 상단부 메인 카테고리를 관할하는 클래스
 */
var MainMenuMgr = 
{
	homemenu_div : null,
	messagesmenu_div : null,
	peoplemenu_div : null,
	topicsmenu_div : null,
	moremenu_div : null,
	
	menu_div : null,
	
	current_state : 0
}

/**
 * MainMenuMgr 초기화
 */
MainMenuMgr.Init = function()
{
	this.homemenu_div = document.getElementById("HomeMenu");
	this.messagesmenu_div = document.getElementById("MessagesMenu");
	this.peoplemenu_div = document.getElementById("PeopleMenu");
	this.topicsmenu_div = document.getElementById("TopicsMenu");
	this.moremenu_div = document.getElementById("MoreMenu");
	this.menu_div = document.getElementById("BackgroundDiv");
}

MainMenuMgr.Show = function()
{
	this.menu_div.style.display = DISPLAY_BLOCK;
}

MainMenuMgr.Hide = function()
{
	this.menu_div.style.display = DISPLAY_NONE;
	this.HideHomeMenu();
	this.HideMessagesMenu();
	this.HidePeopleMenu();
	this.HideTopicsMenu();
	this.HideMoreMenu();
}

MainMenuMgr.HideHomeMenu = function()
{
	this.homemenu_div.style.display = DISPLAY_NONE;	
}

MainMenuMgr.HideMessagesMenu = function()
{
	this.messagesmenu_div.style.display = DISPLAY_NONE;
}

MainMenuMgr.HidePeopleMenu = function()
{
	this.peoplemenu_div.style.display = DISPLAY_NONE;
}

MainMenuMgr.HideTopicsMenu = function()
{
	this.topicsmenu_div.style.display = DISPLAY_NONE;
}

MainMenuMgr.HideMoreMenu = function()
{
	this.moremenu_div.style.display = DISPLAY_NONE;	
}

/**
 * 현재 화면에 표시될 메인카테고리를 화면에 표시
 */
MainMenuMgr.ShowCurrentMenu = function()
{
	MainMenuMgr.Show();
	switch(this.current_state)
	{
		case 0:
			this.ShowHomeMenu();
			break;
		case 1:
			this.ShowPeopleMenu();
			break;
		case 2:
			this.ShowMessagesMenu();
			break;
		case 3:
			this.ShowTopicsMenu();
			break;
		case 4:
			this.ShowMoreMenu();
			break;
	}
}

/**
 * 현재 State를 반환
 */
MainMenuMgr.getCurSection = function() {
	return this.current_state;
}

/**
 * 이전 카테고리를 화면에 표시
 */
MainMenuMgr.ShowPrevMenu = function()
{
	if (!bFocusable) return false;
	this.Hide();
	
	this.current_state--;
	if(this.current_state<0)
		this.current_state = 4;
	
	this.ShowCurrentMenu();

	//interactive remote start
	iRemoteTW.onLoad();
	//interactive remote end
	return true;
}

/**
 * 다음 카테고리를 화면에 표시
 */
MainMenuMgr.ShowNextMenu = function()
{
	if (!bFocusable) return false;
	alert("MainMenuMgr.ShowNextMenu()");
	this.Hide();
	this.current_state = (this.current_state+1) % 5;
	this.ShowCurrentMenu();

	//interactive remote start
	iRemoteTW.onLoad();
	//interactive remote end
	return true;
}

MainMenuMgr.ShowHomeMenu = function()
{
	this.Hide();
	this.current_state = 0;
	this.homemenu_div.style.display = DISPLAY_BLOCK;
	this.Show();	
}

MainMenuMgr.ShowMessagesMenu = function()
{
	this.messagesmenu_div.style.display = DISPLAY_BLOCK;
}

MainMenuMgr.ShowPeopleMenu = function()
{
	this.peoplemenu_div.style.display = DISPLAY_BLOCK;
}

MainMenuMgr.ShowTopicsMenu = function()
{
	this.topicsmenu_div.style.display = DISPLAY_BLOCK;
}

MainMenuMgr.ShowMoreMenu = function()
{
	this.moremenu_div.style.display = DISPLAY_BLOCK;	
}
