/**
 * Home 카테고리의 새글작성 팝업을 구현한 클래스
 * @class Home 카테고리의 새글작성 팝업을 구현한 클래스
 */
var MultilineIME =
{	
	ime : null,
	
	return_focus_object : null,
	
	current_status : null,
	back_func : null,
	strDefaultMsg : "",
	strLastMsg : "",
	
	KEYPAD_X : 600, KEYPAD_Y : 105, MAX_LENGTH : 140
	
	, onEnterListner : null
	, objInput : null
	, objPreview : null
}

/**
 * MultilineIME 초기화
 */
MultilineIME.Init = function()
{
	UIMultilineIME.Init();

	if (!this.ime)
		this.ime = new IMEShell("MultilineIMEInputText", MultilineIME.InitCallback);
	MultilineIME.objInput = document.getElementById("MultilineIMEInputText");
	MultilineIME.objPreview = document.getElementById("MultilineIME_Preview");
}

/**
 * @see TwitterReplyIME.SetReturnFocusFunc 
 */
MultilineIME.SetReturnFocusFunc = function(object_name)
{
	this.return_focus_object = object_name;
}

/**
 * 새글작성 팝업에 키입력 포커스를 준다.
 */
MultilineIME.Focus = function()
{
	MultilineIME.objInput.focus();
}

//화면에 키패드와 input객체를 보인다.
MultilineIME.Show = function(status, pOnEnterListner, pReturnListner, pTitle, pSubtitle, pDefaultMsg)
{
	pDefaultMsg = typeof(pDefaultMsg) == "string" ? pDefaultMsg.toHTML() : pDefaultMsg;
	TWAlert("MultilineIME.Show : " + pTitle + ", " + pSubtitle + ", " + pDefaultMsg);
	if (typeof(pDefaultMsg) == "string" && pDefaultMsg.length > 140)
		pDefaultMsg = pDefaultMsg.slice(0, 140);
	this.back_func = pReturnListner;
	this.current_status = status;
	
	// Regist event listner
	this.onEnterListner = pOnEnterListner ? pOnEnterListner : function(){};
	this.strDefaultMsg = pDefaultMsg;

	UIMultilineIME.SetTitle(pTitle);
	UIMultilineIME.SetSubTitle(pSubtitle);
	UIMultilineIME.SetRemain(this.MAX_LENGTH - pDefaultMsg.length);
	UIMultilineIME.Show();
	UIMultilineIME.UpdatePreview(this.strDefaultMsg.toSeperate());

//	MultilineIME.ime.setString(pDefaultMsg);
	setTimeout (function(){
		MultilineIME.ime.setString(pDefaultMsg);
	},0);
//	MultilineIME.ime.inputObj.cursorPosition = MultilineIME.ime.inputObj.length;
	
	HelpNavigationMgr.ShowMultilineHelp();

	setTimeout("MultilineIME.SetIMEFocus()", 0);
}

MultilineIME.SetIMEFocus = function() {
	this.Focus();
}

/**
 * IME 레퍼런스 참조
 */
MultilineIME.InitCallback = function(imeobj)
{	
	var inputobj = imeobj.getInputObj();
	
	alert("start initializing : "+inputobj.id);
	
	imeobj.setKeypadPos(MultilineIME.KEYPAD_X, MultilineIME.KEYPAD_Y);
	Util.T9WordBoxPos(imeobj);	
	
	imeobj.setEnterFunc(MultilineIME.OnEnter);
	imeobj.setKeyFunc(tvKey.KEY_RETURN, MultilineIME.OnReturn);
	imeobj.setAnyKeyFunc(MultilineIME.OnAnyKey);
	
	alert("ime_init end...");
	
}

/**
 * 아무키나 눌렀을 때 호출되는 콜백함수 
 */
MultilineIME.OnAnyKey = function()
{
	var text = MultilineIME.objInput.value;
	if (text != MultilineIME.strLastMsg) {
		MultilineIME.objPreview.innerHTML = text.toSeperate(25);
		UIMultilineIME.SetRemain(MultilineIME.MAX_LENGTH - text.length);
		MultilineIME.strLastMsg = text;
	}
}

/**
 * 엔터키를 눌렀을 때 호출 되는 콜백 함수
 */
MultilineIME.OnEnter = function()
{
	MultilineIME.UpdateStatus();
}

/**
 * 새 글을 포스팅 하는 함수
 */
MultilineIME.UpdateStatus = function()
{
	var strInputMsg = MultilineIME.objInput.value;
	// Mention시 To ID 변경되는 케이스를 위한 코드
	// strInputMsg = (strInputMsg != this.strDefaultMsg) ? strInputMsg : "";
	MultilineIME.onEnterListner(strInputMsg);
}

/**
 * 리턴키를 눌렀을 때 호출되는 콜백 함수
 */
MultilineIME.OnReturn = function()
{
	alert("MultilineIME.OnReturn");
	
	UIMultilineIME.Hide();

	//interactive remote start
	iRemoteTW.IMEcancel();
	//interactive remote end
	YesNoPopupMgr.Show(function(return_code) {
			if (return_code == 0) {
				MultilineIME.Hide();
				MultilineIME.back_func();
			}
			else {
				UIMultilineIME.Show();
				MultilineIME.Focus();
			}
		});
}

/**
 * 새글작성 팝업을 화면에서 숨기는 함수
 */
MultilineIME.Hide = function()
{
	if(MultilineIME.return_focus_object)
		MultilineIME.return_focus_object.focus();
	UIMultilineIME.Hide();
}