/**
 * M/N 페이지 번호 표시기능을 구현한 클래스
 * @class M/N 페이지 번호 표시기능을 구현한 클래스
 */
var PageIndicatorMgr = 
{
	DEFAULT_LEFT : 696
	, DEFAULT_TOP : 68
	, nCurPage : 0
	, nTotalPage : 0
}

/**
 * PageIndicatorMgr 초기화
 */
PageIndicatorMgr.Init = function()
{
	alert("PageIndicatorMgr.Init()");
	UIPageIndicator.Init();	
}

/**
 * 페이지 번호를 화면에 표시하는 함수
 * @param {Number} x 화면에 표시된 X좌표
 * @param {Number} y 화면에 표시된 Y좌표
 */
PageIndicatorMgr.Show = function(x, y)
{
	alert("PageIndicatorMgr.Show()");
	this.Move(x, y);
	UIPageIndicator.Show();
}

/**
 * 페이지 번호를 화면에서 숨기는 함수
 */
PageIndicatorMgr.Hide = function()
{
	alert("PageIndicatorMgr.Hide()");
	UIPageIndicator.Hide();
}

/**
 * 페이지 번호를 화면에서 숨겼다가 다시 표시하는 함수
 */
PageIndicatorMgr.Refresh = function()
{
	alert("PageIndicatorMgr.Refresh()");
	UIPageIndicator.Refresh();
}

/**
 * 실제 페이지 번호를 설정하는 함수
 * @param {Number} pCurPage 현재 페이지 번호
 * @param {Number} pTotalPage 총 페이지 수
 */
PageIndicatorMgr.SetIndicatorText = function(pCurPage, pTotalPage)
{
	alert("PageIndicatorMgr.SetIndicatorText()");
	this.nCurPage = pCurPage;
	this.nTotalPage = pTotalPage;
	UIPageIndicator.SetIndicatorText(pCurPage,pTotalPage);
}

/**
 * Return total page length
 * @return 	{Number} 		Total page length
 */
PageIndicatorMgr.getTotalPage = function() {
	return this.nTotalPage;
}

/**
 * Return current page
 * @return 	{Number} 		Current page
 */
PageIndicatorMgr.getCurPage = function() {
	return this.nCurPage;
}

/**
 * 실제 화면에서 보이는 위치를 이동하는 함수
 * @param {Number} x X좌표
 * @param {Number} y Y좌표
 */
PageIndicatorMgr.Move = function(x, y)
{
	alert("PageIndicatorMgr.Move()");
	if(x==null)
		x=this.DEFAULT_LEFT;
	if(y==null)
		y=this.DEFAULT_TOP;
	UIPageIndicator.Move(x,y);
}