/**
 * People카테고리를 구현한 클래스
 * @class People카테고리를 구현한 클래스
 */
var PeopleMgr = 
{
	current_page : 1,
	current_index : 0,
	max_page : -1,
	is_first_show : true,
	current_user_list : null,
	current_status_cut_list : null,
	key_anchor : null,
	
	following_data : null,
	followers_data : null,
	
	following_update : false,
	followers_update : false,
	
	mode : 1,
	
	COUNT_IN_PAGE : 4
}
	
/**
 * PeopleMgr 초기화
 */
PeopleMgr.Init = function()
{
	alert("PeopleMgr.Init()");
	UIPeople.Init();

	this.key_anchor = document.getElementById("PeopleKeyAnchor");
	this.following_data = new PeopleMgrData(1,0,-1,true,null);
	this.followers_data = new PeopleMgrData(1,0,-1,true,null);
}

/**
 * 현재 모드를 얻는 함수
 * @return {Number} 1:Following, 2:Followers
 */
PeopleMgr.GetMode = function()
{
	return this.mode;	
}

/**
 * Following과 Followers를 전환할 때 전환하기 전의 데이터를 저장해 두는 함수
 */
PeopleMgr.SavePeopleMgrData = function()
{
	var current_data = null;
	if(this.mode == TwitterDefine.People.Following)
		this.following_data = new PeopleMgrData(this.current_page, this.current_index, this.max_page,
												this.is_first_show, this.current_user_list);
	else if(this.mode == TwitterDefine.People.Followers)
		this.followers_data = new PeopleMgrData(this.current_page, this.current_index, this.max_page,
												this.is_first_show, this.current_user_list);
}

/**
 * Following과 Followers를 전환할 때 해당 데이터 값으로 할당하는 함수
 * @param {DirectMessagesMgrData} data 바꿀 데이터 값
 */
PeopleMgr.AssignPeopleMgrData = function(data)
{
	alert("PeopleMgr.AssignPeopleMgrData()");
	alert(data.CurrentPage);
	alert(data.CurrentIndex);
	alert(data.MaxPage);
	alert(data.IsFirstShow);
	alert(data.CurrentUserList);
	
	this.current_page = 1;
	this.current_index = 0;
	this.max_page = data.MaxPage;
	this.is_first_show = data.IsFirstShow;
	this.current_user_list = data.CurrentUserList;
}

/**
 * Following과 Followers를 전환하는 함수
 */
PeopleMgr.SwitchMode = function()
{
	alert("PeopleMgr.SwitchMode() -> " + this.mode);
	PeopleMgr.SavePeopleMgrData();
	if(this.mode == TwitterDefine.People.Following)
	{
		PeopleMgr.AssignPeopleMgrData(this.followers_data);
		this.mode = TwitterDefine.People.Followers;
	}
	else if(this.mode == TwitterDefine.People.Followers)
	{
		PeopleMgr.AssignPeopleMgrData(this.following_data);
		this.mode = TwitterDefine.People.Following;
	}

	//interactive remote start
	iRemoteTW.onLoad();
	//interactive remote end
}

/**
 * 해당 사용자를 선택하는 함수
 */
PeopleMgr.SelectUser = function()
{
	alert("PeopleMgr.SelectUser()");

	var x=705,y=0;
	switch(this.current_index)
	{
		case 0:
			y=98;
			break;
		case 1:
			y=196;
			break;
		case 2:
			y=293;
			break;
		case 3:
			y=301;
			break;
	}
	HomePopupMgr.Show(x, y, this.current_status_cut_list[this.current_index], 2);

	//interactive remote start
	iRemoteTW.popup((4*(this.current_page-1)) + this.current_index);
	//interactive remote end
}

/**
 * People 카테고리에 키 입력 포커스를 주는 함수
 */
PeopleMgr.Focus = function()
{
	this.key_anchor.focus();
}

/**
 * People 카테고리를 화면에서 숨겼다가 다시 보여주는 함수
 */
PeopleMgr.Refresh = function()
{
	UIPeople.Hide();
	UIPeople.Show();
}

/**
 * 현재 선택되고 있는 포커스의 실제 인덱스를 구하는 함수
 * @return {Number} 선택되고 있는 포커스의 실제 인덱스
 */
PeopleMgr.GetRealIndex = function()
{
	return ((this.current_page-1)*this.COUNT_IN_PAGE+this.current_index);	
}

/**
 * Following or Followers 사용자 리스트를 얻었을 때 호출되는 콜백 함수
 * @param {Object} list 얻어온 리스트
 * @param {Number} cursor 다음 데이터 요청 때 사용하는 일종의 식별자, -1은 맨처음 시작 
 */
PeopleMgr.OnGetList = function(list, cursor)
{
	alert("PeopleMgr.OnGetList()");
	PeopleMgr.is_first_show = false;
	PeopleMgr.Focus();
	if (list) {
		var tmp_list = new Array();
		for(var i=0; i<list.length; i++)
		{
			if(list[i])
				tmp_list[tmp_list.length] = list[i];
		}
		list = tmp_list;
		if(cursor==-1)
			PeopleMgr.current_user_list = list;
		else
		{
			for(var i=0; i<list.length; i++)
				PeopleMgr.current_user_list[PeopleMgr.current_user_list.length] = list[i];
			PeopleMgr.Focus();
		}
		if (PeopleMgr.mode == TwitterDefine.People.Following) 
		{
			/*
			if (list instanceof Array) {
				var nLength = list.length;
				var arrFollowing = new Array();
				for (var idx = 0; idx < nLength; idx++) {
					arrFollowing.push(list[idx].UserId);
				}
				People.SetFollowingIdList(arrFollowing);
			}
			*/
			var nFollowing = People.getFollowingsQuantity();
			var strMsg = nFollowing > 1 ? TWID_YOU_FOLLOW_N_PEOPLE.Replace(nFollowing) : TWID_YOU_FOLLOW_1_PEOPLE;
			UIPeople.SetMessage(strMsg);
		}					
		else if(PeopleMgr.mode == TwitterDefine.People.Followers)
		{
			/*
			if (list instanceof Array) {
				var nLength = list.length;
				var arrFollower = new Array();
				for (var idx = 0; idx < nLength; idx++) {
					arrFollower.push(list[idx].UserId);
				}
				People.SetFollowersIdList(arrFollower);
			}
			*/
			var nFollower = People.getFollowersQuantity();
			var strMsg = nFollower > 1 ? TWID_YOUR_N_FOLLOWERS.Replace(nFollower) : TWID_YOU_FOLLOW_1_PEOPLE;
			UIPeople.SetMessage(strMsg);
		}
	} else {
		TWAlert_("No Followers, No Followings");
		UIPeople.SetMessage("");
		PeopleMgr.current_user_list = null;
		if (PeopleMgr.mode ==  TwitterDefine.People.Following) 
        {
			//interactive remote start
          
		   	iRemoteTW.noPeopleFollow("You Follow No People",SID_FIND_SOME_FRIENDS_AND_FOLLOW_WHAT_THEY_DOING);
			//interactive remote end
			People.SetFollowingIdList(null);
		
        }else if(PeopleMgr.mode == TwitterDefine.People.Followers)
        {
			//interactive remote start
           	
			iRemoteTW.noPeopleFollow("You Have No Follower",SID_FIND_SOME_FRIENDS_AND_FOLLOW_WHAT_THEY_DOING);
			//interactive remote end
			People.SetFollowersIdList(null);
            }
		PeopleMgr.Display();
		LoadingMgr.Hide();
		return;
	}
	
	// Adjust focus
	if (PeopleMgr.GetRealIndex() >= PeopleMgr.current_user_list.length) {
		PeopleMgr.current_index--;
		if (PeopleMgr.current_index < 0) {
			PeopleMgr.current_page--;
			PeopleMgr.current_index = PeopleMgr.COUNT_IN_PAGE-1;
		}
	}
	PeopleMgr.Display();
	LoadingMgr.Hide();
}

/**
 * Following or Followers 사용자 리스트를 얻어오는 함수
 * @param {Object} cursor -1:처음 얻어올 때, 그 이외는 요청한 후 응답받은 데이터에 있는 cursor값
 */
PeopleMgr.GetList = function(cursor)
{
	LoadingMgr.Show();
	KeyHandler.FocusNoKey();
	var index = (this.current_page-1)*this.COUNT_IN_PAGE;
	
	if (this.mode == 1) 
	{
		alert("PeopleMgr.GetList 1");
		People.SetGetFollowingUserReturnFunc(PeopleMgr.OnGetList);
		//People.GetFollowingUser(ID, -1);
		People.GetFollowingUser(ID, cursor);
	}
	else if(this.mode == 2)
	{
		alert("PeopleMgr.GetList 2");
		
		People.SetGetFollowersUserReturnFunc(PeopleMgr.OnGetList);
		//People.GetFollowersUser(ID, -1);
		People.GetFollowersUser(ID, cursor);
	}
}

/**
 * 화면에 보일 갯수 만큼만 리스트를 자르는 함수
 */
PeopleMgr.CutList = function()
{
	var lowerbound = (this.current_page-1) * this.COUNT_IN_PAGE;
	var upperbound = (this.current_page-1) * this.COUNT_IN_PAGE + this.COUNT_IN_PAGE;
	
	var list = new Array();
	for(var i=lowerbound; i<upperbound; i++)
	{
		if(this.current_user_list[i])
			list[list.length] = this.current_user_list[i];
	}
	
	this.current_status_cut_list = list;
}

/**
 * 해당(Following or Followers) 사용자 리스트를 업데이트 할 내용이 있을 때 호출하는 함수.
 * 이 함수를 호출하고 Show함수를 호출하면 업데이트 할 내용이 있으면 업데이트 함.
 * @param {Number} mode 1:Following, 2:Followers
 */
PeopleMgr.SetUpdate = function(mode)
{
	switch(mode)
	{
		case 1:
			this.following_update = true;
			break;
		case 2:
			this.followers_update = true;
			break;
	}
}

/**
 * People 카테고리를 화면에 표시하는 함수
 */
PeopleMgr.Show = function()
{	
	UIPeople.Show();
	if(this.is_first_show)
	{
		LoadingMgr.Show();
		KeyHandler.FocusNoKey();
		PeopleMgr.GetList(-1);
	}
	else if(this.GetMode()==1 && this.following_update)
	{
		LoadingMgr.Show();
		KeyHandler.FocusNoKey();
		PeopleMgr.GetList(-1);
		PeopleMgr.following_update = false;
	}
	else if(this.GetMode()==2 && this.followers_update)
	{
		LoadingMgr.Show();
		KeyHandler.FocusNoKey();
		PeopleMgr.GetList(-1);
		PeopleMgr.followers_update = false;
	}
	else
	{
		this.current_page = 1;
		this.current_index = 0;

		PeopleMgr.Focus();
		this.Display();
		
		if (this.mode == TwitterDefine.People.Following) 
		{
			var nFollowing = People.getFollowingsQuantity();
			var strMsg = nFollowing > 1 ? TWID_YOU_FOLLOW_N_PEOPLE.Replace(nFollowing) : TWID_YOU_FOLLOW_1_PEOPLE;
			UIPeople.SetMessage(strMsg);
			HelpNavigationMgr.ShowPeopleHelp(this.mode);
		}					
		else if(this.mode ==  TwitterDefine.People.Followers)
		{
			var nFollower = People.getFollowersQuantity();
			var strMsg = nFollower > 1 ? TWID_YOUR_N_FOLLOWERS.Replace(nFollower) : TWID_YOU_FOLLOW_1_PEOPLE;
			UIPeople.SetMessage(strMsg);
			HelpNavigationMgr.ShowPeopleHelp(this.mode);
		}
	}
}

/**
 * People 카테고리를 화면에서 숨기는 함수
 */
PeopleMgr.Hide = function()
{
	HelpNavigationMgr.HidePeopleHelp();
	ScrollBarMgr.Hide();
	PageIndicatorMgr.Hide();
	UIPeople.Hide();
	PageIndicatorMgr.Hide();
	
	// If contents is not ready
	if (!this.Ready.get()) UIMisc.hideNoContents();
}

/**
 * 포커스를 하나 위로 올리는 함수
 */
PeopleMgr.MoveUp = function()
{
	if(!this.current_user_list)
		return;
	alert("PeopleMgr.MoveUp()");
	this.current_index--;
	
	if(this.GetRealIndex() < 0)
	{
		this.current_page = Math.floor((this.current_user_list.length-1)/this.COUNT_IN_PAGE)+1;
		this.current_index = (this.current_user_list.length-1)%this.COUNT_IN_PAGE;
		alert("** " + this.current_user_list.length);
	}
	else if(this.current_index<0)
	{
		this.current_page--;
		this.current_index = this.COUNT_IN_PAGE-1;
	}
	
	this.Display();	
}

/**
 * 포커스를 하나 아래로 내리는 함수
 */
PeopleMgr.MoveDown = function()
{
	if(!this.current_user_list) return;
	TWAlert("PeopleMgr.MoveDown()");
	
	if ((this.GetRealIndex() + 1) >= this.current_user_list.length) {
		this.More(function(pIsMore){
			if (!pIsMore) {
				PeopleMgr.current_page = 1;
				PeopleMgr.current_index = 0;
				PeopleMgr.Display();
			} else {
				PeopleMgr.moveNext();
			}
		});
	}
	else {
		PeopleMgr.moveNext();
		this.Display();
	}
}

PeopleMgr.moveNext = function() {
	this.current_index++;
	if (this.current_index % this.COUNT_IN_PAGE == 0) {
		this.current_page++;
		this.current_index = 0;
	}
}

/**
 * 이전 페이지로 이동시키는 함수
 */
PeopleMgr.PageUpList = function()
{
	if(!this.current_user_list)
		return;
	alert("PeopleMgr.PageUpList -> " + this.current_page);
	
	var nTotalPage = Math.floor((this.current_user_list.length-1) / this.COUNT_IN_PAGE)+1;
	if (nTotalPage < 2) return;
	
	this.current_page--;
	
	if (this.current_page <= 0) 
	{
		this.current_page = nTotalPage;
	}
	
	this.current_index = 0;
	this.Display();
}

/**
 * 다음 페이지로 이동시키는 함수
 */
PeopleMgr.PageDownList = function()
{
	if(!this.current_user_list)
		return;
	alert("PeopleMgr.PageDownList -> " + this.current_page);
	
	var nTotalPage = Math.ceil(PeopleMgr.current_user_list.length / PeopleMgr.COUNT_IN_PAGE);
	if (nTotalPage < 2) return;
	
	if (PeopleMgr.current_page + 1 > nTotalPage) 
	{
        PeopleMgr.More(function(pIsMore){
			if (!pIsMore) {
				PeopleMgr.current_page = 1;
				PeopleMgr.current_index = 0;
				PeopleMgr.Display();
			} else {
				_NextPage(false);
			}
        });
	}
	else {
		_NextPage();
		PeopleMgr.Display();
	}
	
	function _NextPage(pConditional) {
		PeopleMgr.current_page++;
		if (pConditional && PeopleMgr.current_page > nTotalPage) 
		{
			PeopleMgr.current_page=1;
		}
		PeopleMgr.current_index = 0;
	}
}

/**
 * People 카테고리의 실제 내용을 그리는 함수
 */
PeopleMgr.Display = function()
{
//	alert("PeopleMgr.Display() -> " + this.GetRealIndex() + " " + People.GetFollowingIdList().length);
	var TempList = null;
	if(this.mode == TwitterDefine.People.Following) {
		TempList = People.GetFollowingIdList();
	}
	else if(this.mode == TwitterDefine.People.Followers) {
		TempList = People.GetFollowersIdList();
	}
	if(TempList instanceof Array)
	{
		this.CutList();
		
		if (PeopleMgr.current_page > Math.ceil(PeopleMgr.current_user_list.length / PeopleMgr.COUNT_IN_PAGE)) 
		{
			PeopleMgr.current_page=1;
		}
		
		if (this.current_status_cut_list instanceof Array && this.current_status_cut_list.length > 0) {
			if (this.current_user_list.length > this.COUNT_IN_PAGE) {
				ScrollBarMgr.Display(this.GetRealIndex(), this.current_user_list.length);
				ScrollBarMgr.Show();
				ScrollBarMgr.Refresh();
			} else {
				ScrollBarMgr.Hide();
			}
			PageIndicatorMgr.SetIndicatorText(this.current_page, Math.floor((this.current_user_list.length - 1) / this.COUNT_IN_PAGE) + 1);
			PageIndicatorMgr.Show();

			UIPeople.Display(this.current_status_cut_list);

			//interactive remote start
			iRemoteTW.people();
			//interactive remote end
		//UIPeople.Hide();	
		}
	}
	else
	{
		this.is_first_show = true;
		UIPeople.Display(null);
		ScrollBarMgr.Hide();	
		PageIndicatorMgr.Hide();
		//UIPeople.Show();
	}
	HelpNavigationMgr.ShowPeopleHelp(this.mode);
}

/**
 * 현재 포커스 인덱스를 구하는 함수
 */
PeopleMgr.GetCurrentIndex = function()
{
	return this.current_index;
}

/**
 * 아직 로드되지 않은 리스트가 있으면 가져오는 함수
 */
PeopleMgr.More = function(pEventListner)
{
	this.nLastIndex = this.current_index;
	this.nLastPage = this.current_page;
	
	alert("PeopleMgr.More()");

	var next_cursor = this.current_user_list[this.current_user_list.length-1].NextCursor;
	
	if (next_cursor != 0) {
		pEventListner(true);
		PeopleMgr.GetList(next_cursor);
	}
	else {
		pEventListner(false);
	}
}

PeopleMgr.RefreshList = function()
{
	alert("PeopleMgr.RefreshList()");
	this.current_page = 1;
	this.current_index = 0;
	PeopleMgr.GetList(-1);
}

/**
 * People 카테고리의 키 핸들러
 */
PeopleMgr.KeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("PeopleMgr.KeyHandler -> KeyCode : " + event.keyCode);
	switch (event.keyCode)
	{
		case tvKey.KEY_RW:
			PeopleMgr.PageUpList();            
            break;
        case tvKey.KEY_FF:
            PeopleMgr.PageDownList();
            break;
		case tvKey.KEY_RIGHT:
			if (MainMenuMgr.ShowNextMenu()) {
				PeopleMgr.Hide();
				HelpNavigationMgr.ShowDirectMessagesHelp(1);
				DirectMessagesMgr.Show();
			}
			break;
		case tvKey.KEY_LEFT:
			if (MainMenuMgr.ShowPrevMenu()) {
				PeopleMgr.Hide();
				HomeMgr.Show();
			}
			break;
		case tvKey.KEY_UP:
			if (!PeopleMgr.Ready.get()) return;
			PeopleMgr.MoveUp();
			break;
		case tvKey.KEY_DOWN:
			if (!PeopleMgr.Ready.get()) return;
			PeopleMgr.MoveDown();
			break;
		case tvKey.KEY_ENTER:
			if (!PeopleMgr.Ready.get()) return;
			HelpNavigationMgr.HidePeopleHelp();
			PeopleMgr.SelectUser();
			break;
		case tvKey.KEY_BLUE:
			this.SwitchMode();
			this.Show();
			break;
		case tvKey.KEY_RED:
			this.RefreshList();
			break;
	}
}

// Manage contents status
PeopleMgr.Ready = {
	flag : false
	, set : function() {
		this.flag = true;
	}
	, unset : function() {
		this.flag = false;
	}
	, get : function() {
		return this.flag
	}
}
