/**
 * Profile>Following or Profile>Followers 기능을 구현한 클래스
 * @class Profile>Following or Profile>Followers 기능을 구현한 클래스
 */
var ProfilePeopleMgr = 
{
	current_page : 1,
	current_index : 0,
	max_page : -1,
	is_first_show : true,
	current_user_list : null,
	current_status_cut_list : null,
	key_anchor : null,
	current_status : null,
	
	following_data : null,
	followers_data : null,
	
	mode : 1,
	fromApp : null,
	
	COUNT_IN_PAGE : 4
}
	
/**
 * ProfilePeopleMgr 초기화 
 */
ProfilePeopleMgr.Init = function()
{
	alert("ProfilePeopleMgr.Init()");
	UIProfilePeople.Init();

	this.key_anchor = document.getElementById("ProfilePeopleKeyAnchor");
	this.following_data = new PeopleMgrData(1,0,-1,true,null);
	this.followers_data = new PeopleMgrData(1,0,-1,true,null);
}

/**
 * @see PeopleMgr.GetMode
 */
ProfilePeopleMgr.GetMode = function()
{
	return this.mode;	
}

/**
 * @see PeopleMgr.SavePeopleMgrData
 */
ProfilePeopleMgr.SavePeopleMgrData = function()
{
	var current_data = null;
	if(this.mode == 1)
		this.following_data = new PeopleMgrData(this.current_page, this.current_index, this.max_page,
												this.is_first_show, this.current_user_list);
	else if(this.mode == 2)
		this.followers_data = new PeopleMgrData(this.current_page, this.current_index, this.max_page,
												this.is_first_show, this.current_user_list);
}

/**
 * @see PeopleMgr.OnGetList
 */
ProfilePeopleMgr.OnGetList = function(list, cursor)
{
	alert(list);
	alert("ProfilePeopleMgr.OnGetList()");
	
	ProfilePeopleMgr.is_first_show = false;
	
	ProfilePeopleMgr.Focus();
	LoadingMgr.Hide();
	
	if(list == null)
	{
		ProfilePeopleMgr.Refresh();
		ProfilePeopleMgr.Display();
		return;
	}
	var tmp_list = new Array();
	for(var i=0; i<list.length; i++)
	{
		if(list[i])
			tmp_list[tmp_list.length] = list[i];
	}
		
	list = tmp_list;
	
	if(cursor == -1)
		ProfilePeopleMgr.current_user_list = list;
	else
	{
		for(var i=0; i<list.length; i++)
			ProfilePeopleMgr.current_user_list[ProfilePeopleMgr.current_user_list.length] = list[i];
	}
	ProfilePeopleMgr.Display();
}

/**
 * @see PeopleMgr.GetList
 */
ProfilePeopleMgr.GetList = function(cursor)
{
	LoadingMgr.Show();
	KeyHandler.FocusNoKey();
	if (this.mode == 1) 
	{
		alert("PeopleMgr.GetList 1");
		People.SetGetFollowingUserReturnFunc(ProfilePeopleMgr.OnGetList);
		People.GetFollowingUser(this.current_status.ScreenName, cursor);
	}
	else if(this.mode == 2)
	{
		alert("PeopleMgr.GetList 2");
		
		People.SetGetFollowersUserReturnFunc(ProfilePeopleMgr.OnGetList);
		People.GetFollowersUser(this.current_status.ScreenName, cursor);
	}
}

/**
 * @see PeopleMgr.CutList
 */
ProfilePeopleMgr.CutList = function()
{
	var lowerbound = (this.current_page-1) * this.COUNT_IN_PAGE;
	var upperbound = (this.current_page-1) * this.COUNT_IN_PAGE + this.COUNT_IN_PAGE;
	
	var list = new Array();
	for(var i=lowerbound; i<upperbound; i++)
	{
		if(this.current_user_list[i])
			list[list.length] = this.current_user_list[i];
	}
	
	this.current_status_cut_list = list;
}

/**
 * @see PeopleMgr.AssignPeopleMgrData
 */
ProfilePeopleMgr.AssignPeopleMgrData = function(data)
{
	alert("ProfilePeopleMgr.AssignPeopleMgrData()");
	alert(data.CurrentPage);
	alert(data.CurrentIndex);
	alert(data.MaxPage);
	alert(data.IsFirstShow);
	alert(data.CurrentUserList);
	
	this.current_page = 1;
	this.current_index = 0;
	this.max_page = data.MaxPage;
	this.is_first_show = data.IsFirstShow;
	
	setTimeout("ProfilePeopleMgr.GetList()",0);
}

/**
 * @see PeopleMgr.SwitchMode
 */
ProfilePeopleMgr.SwitchMode = function()
{
	alert("ProfilePeopleMgr.SwitchMode() -> " + this.mode);
	ProfilePeopleMgr.SavePeopleMgrData();
	if(this.mode == 1)
	{
		ProfilePeopleMgr.AssignPeopleMgrData(this.followers_data);
		this.mode = 2;
	}
	else if(this.mode == 2)
	{
		ProfilePeopleMgr.AssignPeopleMgrData(this.following_data);
		this.mode = 1;
	}
	this.Display();
}

/**
 * @see PeopleMgr.SelectUser
 */
ProfilePeopleMgr.SelectUser = function()
{
	alert("ProfilePeopleMgr.SelectUser()");

	var x=705,y=0;
	switch(this.current_index)
	{
		case 0:
			y=98;
			break;
		case 1:
			y=196;
			break;
		case 2:
			y=293;
			break;
		case 3:
			y=301;
			break;
	}
	
	HomePopupMgr.Show(x, y, this.current_status_cut_list[this.current_index], TwitterDefine.From.Wave);

	//interactive remote start
	iRemoteTW.popup((4*(this.current_page-1)) + this.current_index);
	//interactive remote end
}

/**
 * Profile>Following or Profile>Followers 기능에 키 입력 포커스를 주는 함수
 */
ProfilePeopleMgr.Focus = function()
{
	this.key_anchor.focus();
}

/**
 * Profile>Following or Profile>Followers 기능을 화면에 숨겼닥 다시 표시하는 함수
 */
ProfilePeopleMgr.Refresh = function()
{
	UIProfilePeople.Hide();
	UIProfilePeople.Show();
}

/**
 * 현재 선택된 포커스의 실제 인덱스를 구하는 함수
 */
ProfilePeopleMgr.GetRealIndex = function()
{
	return ((this.current_page-1)*this.COUNT_IN_PAGE+this.current_index);	
}

/**
 * Profile>Following or Profile>Followers 기능을 화면에 표시하는 함수
 * @param {Object} status Profile에서 얻어놓은 사용자 Status
 * @param {Number} mode 1:Following, 2:Followers
 */
ProfilePeopleMgr.Show = function(status, mode, pFrom)
{

	iWave.push(function(status, mode, pFrom) {
		return function() {
			ProfilePeopleMgr.Show(status, mode, pFrom);
		}
	}(status, mode, pFrom));

	alert("ProfilePeopleMgr.Show()");	
	UIProfilePeople.HideAllList();
	UIProfilePeople.Show();
	
	if(status != null)
		this.current_status = status;
		
	if(mode != null)
		this.mode = mode;
		
	if (this.mode == 1) //following 일때
	{
		UIProfilePeople.SetTitle2("> " + TWID_FOLLOWING_SMALL);
		UIProfilePeople.SetMessage(TWID_M_FOLLOWS_N_PEOPLE.Replace(this.current_status.ScreenName, this.current_status.FriendsCount));
	}					
	else if(this.mode == 2) //followers 일때
	{
		UIProfilePeople.SetTitle2("> " + TWID_FOLLOWERS_SMALL);
		UIProfilePeople.SetMessage(TWID_N_FOLLOWERS.Replace(this.current_status.ScreenName, this.current_status.FollowersCount));
	}
	
	HelpNavigationMgr.ShowProfilePeopleHelp();
	
	if(this.is_first_show)
	{
		ProfilePeople.Reset();
		this.current_page = 1;
		this.current_index = 0;
		this.max_page = -1;
		
		LoadingMgr.Show();
		KeyHandler.FocusNoKey();
		ProfilePeopleMgr.GetList(-1);
		
		this.is_first_show = false;
	}
}

/**
 * Profile>Following or Profile>Followers 기능을 화면에서 숨기는 함수
 */
ProfilePeopleMgr.Hide = function()
{
	HelpNavigationMgr.HideProfilePeopleHelp();
	ScrollBarMgr.Hide();
	UIProfilePeople.Hide();
	PageIndicatorMgr.Hide();
	
	this.is_first_show = true;
}

/**
 * 포커스를 하나 위로 올리는 함수
 */
ProfilePeopleMgr.MoveUp = function()
{
	alert("ProfilePeopleMgr.MoveUp()");
	
	if(!this.current_user_list)
		return;
	this.current_index--;
	
	if(this.GetRealIndex() < 0)
	{
		this.current_page = Math.floor((this.current_user_list.length-1)/this.COUNT_IN_PAGE)+1;
		this.current_index = (this.current_user_list.length-1)%this.COUNT_IN_PAGE;
		alert("** " + this.current_user_list.length);
	}
	else if(this.current_index<0)
	{
		this.current_page--;
		this.current_index = this.COUNT_IN_PAGE-1;
	}
	
	this.Display();	
}

/**
 * 포커스를 하나 아래로 내리는 함수
 */
ProfilePeopleMgr.MoveDown = function()
{
	if(!this.current_user_list)
		return;
	TWAlert("ProfilePeopleMgr.MoveDown()");

	if ((this.GetRealIndex() + 1) >= this.current_user_list.length) {
		this.More(function(pIsMore){
			if (!pIsMore) {
				ProfilePeopleMgr.current_page = 1;
				ProfilePeopleMgr.current_index = 0;
				ProfilePeopleMgr.Display();
			} else {
				ProfilePeopleMgr.moveNext();
			}
		});
	}
	else {
		ProfilePeopleMgr.moveNext();
		this.Display();
	}
}

ProfilePeopleMgr.moveNext = function() {
	this.current_index++;
	if (this.current_index % this.COUNT_IN_PAGE == 0) {
		this.current_page++;
		this.current_index = 0;
	}
}

/**
 * 이전 페이지로 가는 함수
 */
ProfilePeopleMgr.PageUpList = function()
{
	if(!this.current_user_list)
		return;
	alert("ProfilePeopleMgr.PageUpList -> " + this.current_page);
	
	var nTotalPage = Math.floor((this.current_user_list.length-1) / this.COUNT_IN_PAGE)+1;
	if (nTotalPage < 2) return;	
	
	this.current_page--;
	
	if (this.current_page <= 0) 
	{
		alert(this.current_user_list.length +" "+this.COUNT_IN_PAGE);
		this.current_page =nTotalPage;
	}
	
	this.current_index = 0;
	this.Display();
}

/**
 * 다음 페이지로 가는 함수
 */
ProfilePeopleMgr.PageDownList = function()
{
	if(!this.current_user_list)
		return;
	alert("ProfilePeopleMgr.PageDownList -> " + this.current_page);
	
	var nTotalPage = Math.ceil(ProfilePeopleMgr.current_user_list.length / ProfilePeopleMgr.COUNT_IN_PAGE);
	if (nTotalPage < 2) return;	
	
	if (ProfilePeopleMgr.current_page + 1 > nTotalPage) 
	{
        ProfilePeopleMgr.More(function(pIsMore){
			if (!pIsMore) {
				ProfilePeopleMgr.current_page = 1;
				ProfilePeopleMgr.current_index = 0;
				ProfilePeopleMgr.Display();
			} else {
				_NextPage(false);
			}
        });
	}
	else {
		_NextPage();
		ProfilePeopleMgr.Display();
	}
	
	function _NextPage(pConditional) {
		ProfilePeopleMgr.current_page++;
		if (pConditional && ProfilePeopleMgr.current_page > nTotalPage) 
		{
			ProfilePeopleMgr.current_page=1;
		}
		ProfilePeopleMgr.current_index = 0;
	}
}

/**
 * Profile>Following or Profile>Followers 기능의 실제 내용을 그리는 함수
 */
ProfilePeopleMgr.Display = function()
{
	alert("ProfilePeopleMgr.Display()");
	this.CutList();
	
	if (ProfilePeopleMgr.current_page > Math.ceil(ProfilePeopleMgr.current_user_list.length / ProfilePeopleMgr.COUNT_IN_PAGE)) 
	{
		ProfilePeopleMgr.current_page=1;
	}
	
	UIProfilePeople.Display(this.current_status_cut_list);
	if(this.mode == 1){
		ScrollBarMgr.Display(this.GetRealIndex(), this.current_user_list.length);

		//interactive remote start
		iRemoteTW.profilePeopleFollowing();
		//interactive remote end
        }
	else if(this.mode == 2){
		ScrollBarMgr.Display(this.GetRealIndex(), this.current_user_list.length);

		//interactive remote start
		iRemoteTW.profilePeopleFollowers();
		//interactive remote end
    }
	ScrollBarMgr.Refresh();
	PageIndicatorMgr.SetIndicatorText(this.current_page,
									  Math.floor((this.current_user_list.length-1)/this.COUNT_IN_PAGE)+1);
	PageIndicatorMgr.Show();	
}

/**
 * 현재 포커스 인덱스를 얻는 함수
 */
ProfilePeopleMgr.GetCurrentIndex = function()
{
	return this.current_index;
}

/**
 * 아직 로드되지 않은 리스트가 있으면 가져오는 함수
 */
ProfilePeopleMgr.More = function(pEventListner)
{
	this.nLastIndex = this.current_index;
	this.nLastPage = this.current_page;
	
	var cursor = this.current_user_list[this.current_user_list.length-1].NextCursor;
	
	if(cursor!=0)
	{
		pEventListner(true);
		ProfilePeopleMgr.GetList(cursor);	
	}
	else
	{
		pEventListner(false);
	}	
}

ProfilePeopleMgr.refreshList = function() {
	TWAlert("ProfilePeopleMgr.refreshList()");	
	UIProfilePeople.Show();
	
	if (ProfilePeopleMgr.mode == 1) //following 일때
	{
		UIProfilePeople.SetTitle2("> " + TWID_FOLLOWING_SMALL);
		UIProfilePeople.SetMessage(TWID_M_FOLLOWS_N_PEOPLE.Replace(this.current_status.ScreenName, this.current_status.FriendsCount));
	}					
	else if(ProfilePeopleMgr.mode == 2) //followers 일때
	{
		UIProfilePeople.SetTitle2("> " + TWID_FOLLOWERS_SMALL);
		UIProfilePeople.SetMessage(TWID_N_FOLLOWERS.Replace(this.current_status.ScreenName, this.current_status.FollowersCount));
	}
	
	HelpNavigationMgr.ShowProfilePeopleHelp();
	
	ProfilePeople.Reset();
	ProfilePeopleMgr.current_page = 1;
	ProfilePeopleMgr.current_index = 0;
	ProfilePeopleMgr.max_page = -1;
	
	LoadingMgr.Show();
	KeyHandler.FocusNoKey();
	ProfilePeopleMgr.GetList(-1);
}

/**
 * Profile>Following or Profile>Followers 기능의 키 핸들러
 */
ProfilePeopleMgr.KeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("ProfilePeopleMgr.KeyHandler -> KeyCode : " + event.keyCode);
	switch (event.keyCode)
	{
		case tvKey.KEY_RW:
			ProfilePeopleMgr.PageUpList();            
            break;

        case tvKey.KEY_FF:
            ProfilePeopleMgr.PageDownList();
            break;

		case tvKey.KEY_UP:
			ProfilePeopleMgr.MoveUp();
			break;

		case tvKey.KEY_DOWN:
			ProfilePeopleMgr.MoveDown();
			break;

		case tvKey.KEY_ENTER:
			ProfilePeopleMgr.SelectUser();
			break;

		case tvKey.KEY_TOOLS:
			break;

		case tvKey.KEY_BLUE:
			this.Hide();
			MainMenuMgr.ShowHomeMenu();
			HomeMgr.Show();
			HomeMgr.Focus();
			break;
			
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			this.Hide();
			iWave.pop();
//				ProfileMgr.Display();
//				UIProfile.Show();
//				ProfileMgr.SetLeftSideFocus();
			break;
		case tvKey.KEY_RED:
			this.refreshList();
			break;
	}
}
