/**
 * Profile 기본기능 팝업을 구현한 클래스
 * @class Profile 기본기능 팝업을 구현한 클래스
 */
var ProfilePopupMgr = 
{
	current_index : 0,
	current_status : null,
	key_anchor : null,
	
	COUNT_IN_MENUITEM : 3,
	
	button_enable_table : null,
	
	//mode : 1
}

/**
 * ProfilePopupMgr 초기화
 */
ProfilePopupMgr.Init = function()
{
	UIProfilePopup.Init();
	
	this.key_anchor = document.getElementById("ProfilePopupKeyAnchor");
}

/**
 * 키 입력 포커스를 주는 함수
 */
ProfilePopupMgr.Focus = function()
{
	this.key_anchor.focus();
}

/**
 * Profile 기본기능 팝업을 화면에 표시하는 함수
 * 인수는 @see HomePopupMgr.Show 참조
 */
ProfilePopupMgr.Show = function(x,y, status)
{
	this.current_index = 0;
	this.current_status = status;
	//this.mode = (mode==null ? 1 : mode);

	alert("ProfilePopupMgr.Show() -> " + this.current_status.ScreenName);
	
	this.button_enable_table = new Array();
	for(var i=0; i<this.COUNT_IN_MENUITEM; i++)
		this.button_enable_table[i] = true;
	if ((this.current_status.UserId ? this.current_status.UserId : this.current_status.Id) == TwitterMain.SessionUID) 
	{
		UIProfilePopup.DisableBlock();
		this.button_enable_table[2] = false;
		
	}
	else 
		UIProfilePopup.EnableBlock();
		
	if(People.ContainFollowersId(status.UserId))
	{
		UIProfilePopup.EnableDirectMessage();
	}
	else
	{
		UIProfilePopup.DisableDirectMessage();
		this.button_enable_table[1] = false;
	}
	
	UIProfilePopup.Display();
	UIProfilePopup.Show(x,y);
	this.Focus();
}

/**
 * Profile 기본기능 팝업을 화면에서 숨기는 함수
 */
ProfilePopupMgr.Hide = function()
{
	UIProfilePopup.Hide();
}

/**
 * 현재 포커스 인덱스를 얻어내는 함수
 */
ProfilePopupMgr.GetFocusLocation = function()
{
	return this.current_index;
}

/**
 * 포커스를 하나 위로 이동시키는 함수
 */
ProfilePopupMgr.MoveUp = function()
{
	do
	{
		this.current_index--;
		if(this.current_index < 0)
			this.current_index=this.COUNT_IN_MENUITEM-1;
	}while(!this.button_enable_table[this.current_index]);
	UIProfilePopup.Display();
}

/**
 * 포커스를 하나 아래로 이동시키는 함수
 */
ProfilePopupMgr.MoveDown = function()
{
	do
	{
		this.current_index++;
		if(this.current_index >= this.COUNT_IN_MENUITEM)
			this.current_index=0;
	}while(!this.button_enable_table[this.current_index]);
	UIProfilePopup.Display();
}

ProfilePopupMgr.OnBlockFailed = function() {
	alert("ProfilePopupMgr.OnBlockFailed()");
	alert("Block 실패");	
	LoadingMgr.Hide();
    
	//interactive remote start
	iRemoteTW.messgPopup("", SID_ALERT_NETWORKERROR_MSG + " " + ProfilePopupMgr.current_status.ScreenName + "."); 
	//interactive remote end
	MessageBoxMgr.Show("", SID_ALERT_NETWORKERROR_MSG  + " " + 
						   ProfilePopupMgr.current_status.ScreenName + ".",
					   function()
					   {
							ProfilePopupMgr.Hide();
							ProfileMgr.Refresh();
							ProfileMgr.SetRightSideFocus();
							ProfileMgr.ShowPage(1);
					   });
}

/**
 * Block이 성공하면 호출되는 콜백 함수
 */
ProfilePopupMgr.OnBlocksCreateSuccessful = function()
{
	alert("ProfilePopupMgr.OnBlocksCreateSuccessful()");
	alert("Block 성공");	
	LoadingMgr.Hide();
	
	//interactive remote start
	iRemoteTW.messgPopup("",  SID_YOU_ARE_NOW_NO_LONGER_FOLLOWING.Replace(ProfilePopupMgr.current_status.ScreenName)); 
	//interactive remote end
	MessageBoxMgr.Show("", SID_YOU_ARE_NOW_NO_LONGER_FOLLOWING.Replace(ProfilePopupMgr.current_status.ScreenName),
					   function()
					   {
							ProfilePopupMgr.Hide();
							ProfileMgr.Refresh();
							
							if (People.ContainFollowingId(ProfilePopupMgr.current_status.UserId) || People.ContainFollowersId(ProfilePopupMgr.current_status.UserId)) {
								PeopleMgr.SetUpdate(1);
								PeopleMgr.SetUpdate(2);
								HomeMgr.SetUpdate(0);
								HomeMgr.SetUpdate(1);
								HomeMgr.SetUpdate(2);
							}
							
							People.RemoveFollowingID(ProfilePopupMgr.current_status.UserId);
							
							ProfileMgr.RefreshList();
					   });
}

/**
 * 메뉴항목을 선택했을 때의 기능을 수행하는 함수
 */
ProfilePopupMgr.Select = function()
{
	switch(this.current_index)
	{
		case 0:
			this.Hide();
			//interactive remote start
			if (iRemoteTW.brwsrVer) {
				var showElements = null;
				showElements = {
					type: "qwerty",
					identifier: "qwertyProMen",
					title: TWID_MENTION,
					onEvent: "action?ProMen=[$qwertyProMen.value$]"
				}
				$.sfIRemote('menu', showElements);
			}
			//interactive remote end
			MultilineIME.Show(this.current_status
				, function(pInputText){
					TwitterReply.OnEnter(ProfilePopupMgr.current_status.Id, pInputText, 3, SID_TWEET_POSTED)
				}
				,  function() {
					ProfilePopupMgr.Hide();
					ProfileMgr.SetRightSideFocus();

					//interactive remote start
					iRemoteTW.profile();
					//interactive remote end
				 }
				, TWID_MENTION
				, TWID_MENTION + " " + this.current_status.ScreenName
				, "@" + this.current_status.ScreenName + " ");

			break;
		case 1:
			this.Hide();
			//interactive remote start
			if (iRemoteTW.brwsrVer) {
				var showElements = null;
				showElements = {
					type: "qwerty",
					identifier: "qwertyPpmDirMssg",
					title: TWID_DIRECT_MESSAGE,
					onEvent: "action?PpmDirMssg=[$qwertyPpmDirMssg.value$]"
				}
				$.sfIRemote('menu', showElements);
			}
			//interactive remote end
			DirectMessageIME.Show(this.current_status, 
							  	  function()
								  {
								  	DirectMessageIME.Hide();
									//ProfileMgr.Show();
									ProfileMgr.SetRightSideFocus();

									//interactive remote start
									iRemoteTW.profile();
									//interactive remote end
								  }, this.current_status.ScreenName, 4, this.current_status.UserId);
			break;
		case 2:
			this.Hide();
			if ((this.current_status.UserId ? this.current_status.UserId : this.current_status.Id) != TwitterMain.SessionUID) 
			{
				this.Hide();
				YesNoPopupMgr.ShowBlock(function(return_code)
							{
								alert("return_code -> " + return_code);
								if(return_code == 0)
								{
									LoadingMgr.Show();
									KeyHandler.FocusNoKey();
									Blocks.SetCreateErrorFunc(ProfilePopupMgr.OnBlockFailed);
									Blocks.SetCreateReturnFunc(ProfilePopupMgr.OnBlocksCreateSuccessful);
									Blocks.Create(ProfilePopupMgr.current_status.ScreenName);
								}
								else
								{
									ProfilePopupMgr.Hide();
									ProfileMgr.Refresh();
									ProfileMgr.SetRightSideFocus();
								}
							});
			
			}
			break;
	}
}

/**
 * Profile 기본기능 팝업의 키 핸들러
 */
ProfilePopupMgr.KeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("ProfilePopupMgr.KeyHandler() -> KeyCode : " + event.keyCode);
	switch (event.keyCode)
	{
		case tvKey.KEY_UP:
			this.MoveUp();
			break;
		case tvKey.KEY_DOWN:
			this.MoveDown();
			break;
		case tvKey.KEY_ENTER:
			this.Select();
			break;
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			this.Hide();
			
			ProfileMgr.Refresh();
			ProfileMgr.SetRightSideFocus();
			break;
	}
}
