/**
 * Topic Search IME 팝업을 구현한 클래스
 * @class Topic Search IME 팝업을 구현한 클래스
 */
var SearchIME =
{	
	ime : null,
	
	return_focus_object : null,
	
	back_func : null,
	
	KEYPAD_X : 600,
	KEYPAD_Y : 105,
	
	MAX_LENGTH : 100
}

/**
 * SearchIME 초기화
 */
SearchIME.Init = function()
{
	UISearchIME.Init();
	//this.SetReturnFocusFunc(object_name);

	if(!this.ime)
		this.ime = new IMEShell("SearchPopup_Input", SearchIME.InitCallback);	
}

/**
 * 키패드를 닫았을 때 되돌아 갈 포커스 오브젝트 지정
 * @param {Object} object_name 포커스를 가질 수 있는 오브젝트
 */
SearchIME.SetReturnFocusFunc = function(object_name)
{
	this.return_focus_object = object_name;
}

/**
 * Topic Search IME 팝업에 포커스를 주는 함수
 */
SearchIME.Focus = function()
{
	document.getElementById("SearchPopup_Input").focus();	
}

/**
 * Topic Search IME 팝업을 화면에 표시하는 함수
 * @param {Function} back_func 팝업을 닫았을 때 수행하는 함수
 */
SearchIME.Show = function(back_func)
{
	this.back_func = back_func;
	this.Focus();
	SearchIME.ime.setString("");
	UISearchIME.Show();
	UIHelpNavigation.ShowSearchIMEHelp();
}

/**
 * Topic Search IME 팝업의 IME 초기화 함수
 * @param {Object} imeobj IME레퍼런스 참조
 */
SearchIME.InitCallback = function(imeobj)
{	
	var inputobj = imeobj.getInputObj();
	
	alert("start initializing : "+inputobj.id);
	
	imeobj.setKeypadPos(SearchIME.KEYPAD_X, SearchIME.KEYPAD_Y);
	Util.T9WordBoxPos(imeobj);	
	
	//imeobj.setOnCompleteFunc(SearchIME.OnComplete);
	imeobj.setEnterFunc(SearchIME.OnEnter);
	imeobj.setKeyFunc(tvKey.KEY_RETURN, SearchIME.OnReturn);
	//imeobj.setKeyFunc(tvKey.KEY_DOWN, SearchIME.OnDown);
	//imeobj.setKeyFunc(tvKey.KEY_BLUE, SearchIME.OnBlue);
	
	//document.getElementById("SearchPopup_Input").focus();
	//document.getElementById("SearchPopup_Input").style.display = DISPLAY_BLOCK;
	alert("ime_init end...");
}
/*
//한문자가 완성되었을 때 호출 됨
SearchIME.OnComplete = function(text)
{
}

SearchIME.OnBlue = function()
{
	alert("SearchIME.OnBlue()");
	
}

SearchIME.OnDown = function()
{
	widgetAPI.blockNavigation(event);
}
*/
/**
 * 엔터키를 눌렀을 때 호출 되는 콜백 함수 
 */
SearchIME.OnEnter = function()
{
	var text = document.getElementById("SearchPopup_Input").value;
	
	if (text == "") 
	{
		UISearchIME.Hide();
        
		//interactive remote start
		iRemoteTW.messgPopup("", SID_MIX_MESSAGES_MOT_EXCEED_A_CHARACTERS.Replace("140")); 
		//interactive remote end
		MessageBoxMgr.Show("", SID_MIX_MESSAGES_MOT_EXCEED_A_CHARACTERS.Replace("140"), 
							function()
							{
								UISearchIME.Show();
								SearchIME.Focus();
							});
	}
	else 
	{
		SearchMgr.Show(text, true);
		MainMenuMgr.Hide();
		SearchIME.Hide();
		TopicsMgr.Hide();
		SearchMgr.Focus();
		//interactive remote start
		iRemoteTW.newTopicSearch(text);

         	text ="";
		//interactive remote end
	}
}

/**
 * 리턴키를 눌렀을 때 호출 되는 콜백 함수 
 */
SearchIME.OnReturn = function()
{
	alert("SearchIME.OnReturn()");
	UISearchIME.Hide();

	//interactive remote start
	iRemoteTW.searchIMEcancel();
	//interactive remote end
	YesNoPopupMgr.Show(function(return_code)
						{
							alert("return_code -> " + return_code);
							if(return_code == 0)
							{
								SearchIME.back_func();	
							}
							else
							{
								UISearchIME.Show();
								SearchIME.Focus();	
							}
						});
}

/**
 * Topic Search IME 팝업을 화면에서 숨기는 함수
 */
SearchIME.Hide = function()
{
	SearchIME.ime.setString("");
	//document.getElementById("ReplyIMEInputText").style.display = DISPLAY_NONE;
	if(SearchIME.return_focus_object)
		SearchIME.return_focus_object.focus();
	UIHelpNavigation.HideSearchIMEHelp();
	UISearchIME.Hide();
}