/**
 * 버튼 두개를 가진 메시지 박스를 구현한 클래스
 * @class 버튼 두개를 가진 메시지 박스를 구현한 클래스
 */
var YesNoPopupMgr =
{
	current_index : 1,
	key_anchor : null,
	return_func : null
}

YesNoPopupMgr.Init = function()
{
	UIYesNoPopup.Init();
	
	this.key_anchor = document.getElementById("YesNoPopupKeyAnchor");
}

YesNoPopupMgr.Focus = function()
{
	this.key_anchor.focus();
}

YesNoPopupMgr.SetFocusLocation = function(index)
{
	this.current_index = index;
}

YesNoPopupMgr.moveFocus = function() {
	this.current_index = this.current_index == 0 ? 1 : 0;	
	if (this.current_index == 0) {
		UIYesNoPopup.HideNoHighlight();
		UIYesNoPopup.ShowYesHighlight();
	} else {
		UIYesNoPopup.HideYesHighlight();
		UIYesNoPopup.ShowNoHighlight();
	}
}

YesNoPopupMgr.GetFocusLocation = function()
{
	return this.current_index;
}

/**
 * 일반 취소 메시지 박스
 * @param {Object} return_func 첫번째 버튼을 눌렀을 때 수행할 함수
 */
YesNoPopupMgr.Show = function(return_func)
{
	this.return_func = return_func;
	this.SetFocusLocation(1);
	UIYesNoPopup.SetMessage(SID_CANCEL_EDITING_Q_MSG);
	UIYesNoPopup.Display();
	UIYesNoPopup.Show();
	this.Focus();
}

/**
 * Block 메시지 박스
 * @param {Object} return_func 첫번째 버튼을 눌렀을 때 수행할 함수
 */
YesNoPopupMgr.ShowBlock = function(return_func)
{
	this.return_func = return_func;
	this.SetFocusLocation(1);
	UIYesNoPopup.SetMessageLong(SID_BLOCKING_USER_WONT_SEE_TWEETS_MSG);

	//interactive remote start
	iRemoteTW.yesNoPopup(SID_BLOCKING_USER_WONT_SEE_TWEETS_MSG);
	//interactive remote end
	UIYesNoPopup.Display();
	UIYesNoPopup.Show();
	this.Focus();
}

/**
 * Delete 메시지 박스
 * @param {Object} return_func 첫번째 버튼을 눌렀을 때 수행할 함수
 */
YesNoPopupMgr.ShowDelete = function(return_func)
{
	this.return_func = return_func;
	this.SetFocusLocation(1);
	UIYesNoPopup.SetMessage(SID_DELETE_THE_SELECTED_TWEET);
	UIYesNoPopup.Display();
	UIYesNoPopup.Show();
	this.Focus();
}

YesNoPopupMgr.Hide = function()
{
	UIYesNoPopup.Hide();
    
    //interactive remote start
	iRemoteTW.popupOff();
	//interactive remote end
}

YesNoPopupMgr.KeyHandler = function()
{
	if (!CUtil.delayKey()) return;
	alert("YesNoPopupMgr.KeyHandler() -> " + event.keyCode);
	switch(event.keyCode)
	{
		case tvKey.KEY_LEFT:
		case tvKey.KEY_RIGHT:
			this.moveFocus();
			break;
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			this.return_func(1);
			this.Hide();
			break;
		case tvKey.KEY_ENTER:
			this.return_func(this.current_index);
			this.Hide();

			break;
	}

}
