var UIProfilePopup = 
{
	profilepopup_div : null,
	mention_text_div : null,
	directmessage_text_div : null,
	block_text_div : null,
	highlight_div : Array(),
}

UIProfilePopup.Init = function()
{
	this.profilepopup_div = document.getElementById("ProfilePopup");
	this.mention_text_div = document.getElementById("ProfilePopup_Mention_Text");
	this.directmessage_text_div = document.getElementById("ProfilePopup_DirectMessage_Text");
	this.block_text_div = document.getElementById("ProfilePopup_Block_Text");
	
	this.highlight_div[0] = document.getElementById("ProfilePopup_Mention_Highlight");
	this.highlight_div[1] = document.getElementById("ProfilePopup_DirectMessage_Highlight");
	this.highlight_div[2] = document.getElementById("ProfilePopup_Block_Highlight");
	
	this.SetMentionText();
	this.SetDirectMessageText();
	this.SetBlockText();
}

UIProfilePopup.EnableBlock = function()
{
	Util.SetClassToDiv(this.block_text_div, 
					   "ProfilePopup_Enabled_Text_Style");
}

UIProfilePopup.DisableBlock = function()
{
	Util.SetClassToDiv(this.block_text_div, 
					   "ProfilePopup_Disabled_Text_Style");
}

UIProfilePopup.EnableDirectMessage = function()
{
	Util.SetClassToDiv(this.directmessage_text_div, 
					   "ProfilePopup_Enabled_Text_Style");
}

UIProfilePopup.DisableDirectMessage = function()
{
	Util.SetClassToDiv(this.directmessage_text_div, 
					   "ProfilePopup_Disabled_Text_Style");
}

UIProfilePopup.SetMentionText = function()
{
	widgetAPI.putInnerHTML(this.mention_text_div, TWID_MENTION);
}

UIProfilePopup.SetDirectMessageText = function()
{
	widgetAPI.putInnerHTML(this.directmessage_text_div, TWID_DIRECT_MESSAGE);
}

UIProfilePopup.SetBlockText = function()
{
	widgetAPI.putInnerHTML(this.block_text_div, TWID_BLOCK);
}

UIProfilePopup.Show = function(x, y)
{
	this.profilepopup_div.style.left = x;
	this.profilepopup_div.style.top = y;
	this.profilepopup_div.style.display = DISPLAY_BLOCK;
}

UIProfilePopup.Hide = function()
{
	this.profilepopup_div.style.display = DISPLAY_NONE;
}

UIProfilePopup.HideHighlight = function(index)
{
	this.highlight_div[index].style.display = DISPLAY_NONE;
}

UIProfilePopup.ShowHighlight = function(index)
{
	this.highlight_div[index].style.display = DISPLAY_BLOCK;
}

UIProfilePopup.Display = function()
{
	for(var i=0; i<this.highlight_div.length; i++)
	{
		if(i==ProfilePopupMgr.GetFocusLocation())
		{
			this.ShowHighlight(i);
		}
		else
		{
			this.HideHighlight(i);
		}
	}
}