var NETSocket = {}

/**
 * @brief           getXMLHttpRequest
 * @remarks      Get XMLHttpRequest
 * @param			userXHRObject
 * @return			XMLHttpRequest
*/
NETSocket.getXMLHttpRequest = function(userXHRObject){
    if (window.XMLHttpRequest) {
        return new window.XMLHttpRequest;
    }
    else {
        try {
            return new ActiveXObject("MSXML2.XMLHTTP.3.0");
        }
        catch(ex) {
            return null;
        }
    }
}

/**
 * @brief           setRequestHeader
 * @remarks      Set Request Header
 * @param			XmlHttpRequest Object
 * @param			Header name
 * @param			Contents
 * @return			Success | Fail
*/
NETSocket.setRequestHeader = function (XHRObject, header, body) {
    try {
        if (!XHRObject) {
            return false;
        } else {
            XHRObject.setRequestHeader(header, body);
            return true;
        }
    } catch (e) {
	    alert (e);
    }
}

/**
 * @brief           setURL
 * @remarks      Set URL to XHR
 * @param			XmlHttpRequest Object
 * @param			Method
 * @param			Request URL
 * @param			Parameter
 * @param			Callback Function
 * @param			userData
*/
NETSocket.setURL = function(XHRObject, method, url, param, callback){
    try {
        XHRObject.onreadystatechange = function(){
			alert (url  + "'s Ready State : " + XHRObject.readyState);
			if (XHRObject.readyState == 3) {
			} else if (XHRObject.readyState == 4) {
                NETSocket.callBack(XHRObject, XHRObject.status, callback);
            }
        };
        if (param.length > 0) {
            if (param.charAt(0) == '?') {
                url = url + param;
            }
            else {
                url = url + "?" + param;
            }
        }
        XHRObject.open(method, url, true);
        return true;
    } 
    catch (e) {
        alert(e);
    }
}

/**
 * @brief           callURL
 * @remarks      Send Reqeust
 * @param			XmlHttpRequest Object
 * @param			Parameter
*/
NETSocket.callURL = function (XHRObject, param) {
	try {
        if (!XHRObject) {
            return false;
        }
        else {
            if (param == "") {
                XHRObject.send(null);
            }
            else {
                XHRObject.send(param);
            }
        }
	} catch (e) {
		alert(e)
	}
}

/**
 * @brief           callBack
 * @remarks      Callback function for response
 * @param			XmlHttpRequest Object
 * @param			Stat
 * @param			Callback Function
 * @param			User Data
*/
NETSocket.callBack = function (XHRObject, stat, callbackFn){
	try {
	    var result;
		if (stat == "200") {
			callbackFn(XHRObject);
		}
		else {
			alert(XHRObject.responseText);
			alert("stat : " + stat);
			callbackFn(XHRObject);
		}
	} catch (e) {
		alert (e);
	}
}
