alert('SceneSNSList.js loaded');
var bWait = false;
var nTotalLength = 0;
var nCount = 20;

var nLatest;
var nOldest;
var nRefreshLatest = "";
var pParam ="";
var LastFocusID;

var FIRST = 0;
var MORE = 1;
var REFRESH = 2;
var AUTOREFRESH = 3;

function SceneSNSList() {
    
	var $this = this;
	this.iCommentInnerLoading = null;
	
	this.isFocused = false;
	this.isLogin = false;
	
	$this.init = false;

	var sYourVideoID = "11111000000";
	//Interactive Remote Start
	/**
     *@brief SmartPhone action
	 *@remarks function for viewing service setting from Smart device
	 *@param void
	 *@return void
	 */
	this.showServiceInfo=function()
	{
		this.MTwitterList.sendServiceInfo();
	}
	/**
     *@brief SmartPhone action
	 *@remarks function for updating refresh flag from smart device
	 *@param void
	 *@return void
	 */
	this.updateRefreshFlag=function()
	{
		this.MTwitterList.setUpdateTwiterRefreshFlag();
	}
	//Interactive Remote End
	// Event Listener
	this.eventListener = function(pEvent) {
		switch (pEvent) {
			default:
				break;
		}
	}
	this.isReady = function() {
		return $this.MTwitterList.getListLength() > -1 ? true : false; 
	}
	//Interactive Remote Start
	/**
     *@brief SmartPhone action
	 *@remarks function for opening reply Ime  from smart device
	 *@param void
	 *@return void
	 */
	this.openReplyIME=function(pValue)
	{
	       
			IMEOpen({
							title: "Reply",
							caller: "MPopup",
							contents: "@" + pValue.name + " ",
							callback: function(pResult){
										if (pResult) {
											iCommentInnerLoading.open();
											bWait = true;
											$this.TwitterAPI.updateStatus(function(pResult){
												$this.refresh();
												$this.updateRefreshFlag();
												$.sfScene.hide("MPopup");
												
												$.sfScene.show({
													id: "SNSList",
													scope: TWITTER_ID
												});
												$.sfScene.focus({
													id: "SNSList",
													scope: TWITTER_ID
												});
												bWait = false;
											}, {
												'status': pResult
											});
										}
									}
						});
	}
	/**
     *@brief SmartPhone action
	 *@remarks function for opening retweet IME from smart device
	 *@param void
	 *@return void
	 */
	this.openRetweetIME=function(pValue)
	{
	IMEOpen({
							title: "Retweet",
							caller: "MPopup",
							contents: "RT " + pValue.text,
							callback: function(pResult){
										if (pResult) {
											iCommentInnerLoading.open();
											bWait = true;
											$this.TwitterAPI.updateStatus(function(pResult){
												// Refresh after update
												$this.refresh();
												$this.updateRefreshFlag();
												$.sfScene.hide("MPopup");
												$.sfScene.show({
													id: "SNSList",
													scope: TWITTER_ID
												});
												$.sfScene.focus({
													id: "SNSList",
													scope: TWITTER_ID
												});
												bWait = false;
											}, {
												'status': pResult
											});
										}
									}
						});
	}
	/**
     *@brief SmartPhone action
	 *@remarks function for opening what's an IME   from smart device
	 *@param void
	 *@return void
	 */
	this.openWhatsIME=function()
	{
	IMEOpen({ title : "What's happening?", caller : { id : "SNSList", scope : TWITTER_ID } });
	}
	//Interactive Remote End
	this.enter = function(pValue) {
		if ($this.MTwitterList.getCurRealIdx() == -1) {
			//Interactive Remote Start
			$this.MTwitterList.openWhatsHappening();
			//Interactive Remote End
			IMEOpen({ title : TWID_WHATS_HAPPENING, caller : { id : "SNSList", scope : TWITTER_ID }, returnFn: function(pEvent){
				focusCurScene();
				if (pEvent == EVENT_SOCIAL_KEY) {
					$this.returnToCategory();
				}
			},
			focusCtrl : true, callback : function(pInputTxt) {
				$this.update(pInputTxt);
			}
		 });
		}
		else {
			$this.MTwitterList.select();
			var instanceMPopup = $.sfScene.get("MPopup");
			$this.MTwitterList.adjustSubmenuPos(3);
			
			var oMenu = {
				"id" : TWITTER_ID,
				"caller": { id : "SNSList", scope : TWITTER_ID },
				"returnFn" : function(pEvent){
					returnFn(pEvent);
				},
				"items": []
			};
			
			oMenu.items.push({
					"title": TWID_RETWEET_VERB,
					"action": getRetweetFn()
				});
			oMenu.items.push({
					"title": TWID_REPLY,
					"action": getReplyFn()
				});

			if (pValue.text && typeof pValue.text == "string") {
				var aYourVideo = pValue.text.match(/#YourVideo\s[(\s|\w|\W)]*\(([\d]+)_(\w\w)\)/);
				if (aYourVideo && aYourVideo.length == 3) {
					var nGlobalSetting = isYourVideoGlobal();
					if (nGlobalSetting == isYourVideoGlobal.TRUE || nGlobalSetting == isYourVideoGlobal.FALSE) {
						var sBaseCountry = (nGlobalSetting == isYourVideoGlobal.TRUE) ? "US" : InitParam.country;
						if (aYourVideo[2] == sBaseCountry) {
							oMenu.items.push({
								"title": TV_SID_MIX_MOVE_TO.Replace("Your Video"),
								"action": moveToYourVideoFn()
							});
						}
					}
				}
			}	

			oMenu.items.push({
					"title": TV_SID_MIX_MOVE_TO.Replace("Twitter"),
					"action": moveToTwitterFn()
				});
			
			instanceMPopup.set(oMenu);
			$.sfScene.show("MPopup");
			$.sfScene.focus("MPopup");
		}
		
		function getRetweetFn() {
			return function() {
					    //Interactive Remote Start
						$this.MTwitterList.openInteractiveRetweet(pValue);
						//Interactive Remote End
						IMEOpen({
							title: TWID_RETWEET_VERB,
							caller: "MPopup",
							contents: "RT @" + pValue.name + " " + pValue.text,
							focusCtrl : true,
							callback: function(pResult){
										if (pResult && pResult.match(/[^\s]/)) {
											$this.iCommentInnerLoading.open();
											$this.MTwitterList.showLoading();
											bWait = true;
											$this.TwitterAPI.updateStatus(function(pResult, pSuccess){
												bWait = false;
												if (!pSuccess) {
													$this.iCommentInnerLoading.close();
													$this.MTwitterList.hideLoading();
                                                    Misc.networkErrPopup(function(pEvent){
														if (pEvent == EVENT_SOCIAL_KEY) {
															returnFn(pEvent);
															return;
														}
                                                        $.sfScene.focus("MPopup");
                                                    });
													return;
												}
												$.sfScene.hide("MPopup");
												$.sfScene.show({ id: "SNSList", scope: TWITTER_ID});
												focusCurScene();
												$this.refresh();
												$this.updateRefreshFlag();
											}, {
												'status': pResult
											});
										} else {
											 $.sfScene.focus("MPopup");
										}
									},
									returnFn : function(pEvent) {
										 $.sfScene.focus("MPopup");
										if (pEvent == EVENT_SOCIAL_KEY) {
											returnFn(pEvent);
											return;
										}
									}
						});
			}
		}
		
		function getReplyFn() {
			return function() {
			            //Interactive Remote Start
						$this.MTwitterList.openInteractiveReply(pValue);
						//Interactive Remote End
						IMEOpen({
							title: TWID_REPLY,
							caller: "MPopup",
							contents: "@" + pValue.name + " ",
							focusCtrl : true,
							callback: function(pResult){
										if (pResult && pResult.match(/[^\s]/)) {
											$this.iCommentInnerLoading.open();
											$this.MTwitterList.showLoading();
											bWait = true;
											$this.TwitterAPI.updateStatus(function(pResult, pSuccess){
												bWait = false;
												if (!pSuccess) {
													$this.iCommentInnerLoading.close();
                                                    Misc.networkErrPopup(function(pEvent){
														if (pEvent == EVENT_SOCIAL_KEY) {
															returnFn(pEvent);
															return;
														}
                                                        $.sfScene.focus("MPopup");
                                                    });
													return;
												}
												$.sfScene.hide("MPopup");
												$.sfScene.show({ id: "SNSList", scope: TWITTER_ID});
												focusCurScene();
												$this.refresh();
												$this.updateRefreshFlag();
											}, {
												'status': pResult
											});
										} else {
											 $.sfScene.focus("MPopup");
										}
									},
									returnFn : function(pEvent) {
										 $.sfScene.focus("MPopup");
										if (pEvent == EVENT_SOCIAL_KEY) {
											returnFn(pEvent);
											return;
										}
									}
						});
			}
		}

		function moveToYourVideoFn() {
			return function() {
						//Interactive Remote Start
						$this.MTwitterList.openTwitterPopup();
						//Interactive Remote End
						$("#HomePopup").sfPopup({
					        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace("Your Video"), 
					        num : 2,
							focus : "right",
					        callback : function(pRtn) {
								$("#Default_DIM").hide();
								if ( pRtn == true ) {
									runWidget(sYourVideoID, {data :JSON.stringify({ TTID: aYourVideo[1] }) });
								}
								else {
									$("#HomePopup").sfPopup("hide");
								}
							}
						});
						$("#Default_DIM").show();
						$("#HomePopup").sfPopup("show");
			}
		}

		function moveToTwitterFn() {
			return function() {
						//Interactive Remote Start
						$this.MTwitterList.openTwitterPopup();
						//Interactive Remote End
						$("#HomePopup").sfPopup({
					        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace(Util.getWidgetName(TWITTER_ID)), 
					        num : 2,
							focus : "left",
					        callback : function(pRtn) {
										$("#Default_DIM").hide();
										if ( pRtn == true ) {
											$this.MTwitterList.closeOKTwitterPopup();
											var objAccount = TVComm.getAccount(TWITTER_ID);
											runWidget(TWITTER_ID, {
												id: objAccount.id,
												pw: objAccount.pw
											});
										}
										else {
										    $this.MTwitterList.closeTwitterPopup();
											$("#HomePopup").sfPopup("hide");
										}
									}
						});
						$("#Default_DIM").show();
						$("#HomePopup").sfPopup("show");
			}
		}
		
	}

    /*
     	Function: returnFn
     			Control return from submenu

     	Parameters:
     			 pEvent - Event enum
     	Returns:
     			 N/A
     */
	function returnFn(pEvent) {
		switch(pEvent) {
			case EVENT_SOCIAL_KEY :
				$this.returnToCategory();
				break;
			default :
				break;
		}
	}

	/*
     	Function: returnToCategory
     			Focus to category
     */
	this.returnToCategory = function() {
		alert("[SNSList(Twitter)] returnToCategory");
		$.sfKey.block();
		// Focus to category for service change
		$.sfScene.focus("Home");
		$this.blurFocus();
		$this.focusFirstItem();
		$this.blurFocus();
		$this.isFocused = false;	
		$this.showHelpNav();
	}

	this.update = function(pResult){
		if (pResult && pResult.match(/[^\s]/)) {
			$this.iCommentInnerLoading.open();
			//Interactive Remote Start
			$this.MTwitterList.showLoading();
			//Interactive Remote End
			bWait = true;
			$this.TwitterAPI.updateStatus(function(pResult, pSuccess){
				bWait = false;
				$this.iCommentInnerLoading.close();
				//Interactive Remote Start
				$this.MTwitterList.hideLoading();
				//Interactive Remote End
				if (pSuccess) {
					// Refresh after update
					alert(pResult.responseText);
					$this.refresh();
					focusCurScene();
				} else {
					Misc.networkErrPopup(function(pEvent){
						focusCurScene();
						if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();
					});
				}
			}, {
				'status': pResult
			});
		} else {
			focusCurScene();
		}
	}
	
    this.tools = function() {
		var instanceServiceSetting = $.sfScene.get("ServiceSetting");
		instanceServiceSetting.reset();
		instanceServiceSetting.set(function(pEvent){
			if (pEvent == EVENT_SOCIAL_KEY) {
				$this.returnToCategory();
			} else {
				$.sfScene.get("Home").focusCurService();
			}
		});
		$.sfScene.show("ServiceSetting");
        $.sfScene.focus("ServiceSetting");
	}

    /*
     	Function: focusReset
     			Display first page and focus to first item
     */
	this.focusFirstItem = function() {
		$this.MTwitterList.focusFirstItem();
	}
	
	  /*
     	Function: blurFocus
     			Blur current focused item
     */
	this.blurFocus = function() {
		$this.MTwitterList.blur($this.MTwitterList.getCurRealIdx()+1);
	}
		/**
         *@brief SmartPhone action
	 *@remarks function for getting current index from smart device
	 *@param void
	 *@return void
	 */
	this.gettingOldIndex=function()
	{
	 return this.MTwitterList.getCurrentIndex();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for moving item index from smart device
	 *@param void
	 *@return void
	 */
	this.moveToItemIndex=function(prevIndex,newIndex)
	{
		this.MTwitterList.moveToItemIndex(prevIndex,newIndex);
	}
	this.login = function() {
		alert("Twitter Module Login");
		var objAccount = TVComm.getAccount(TWITTER_ID);
		// Defect - P101020-0183
		// 		Handle a case that has no service
		if (objAccount.id) {
			$this.isLogin = true;
			
			// Focus to category for login
			$.sfScene.get("Home").focusToCategory();
			
			$this.iCommentInnerLoading.open();
			//Interactive Remote Start
			$this.MTwitterList.showLoading();
			//Interactive Remote End
			$this.TwitterAPI.login(loginCallback, objAccount.id, objAccount.pw);
		}
	    
		function loginCallback() {
	        startMtwitterHome();
	        autoRefresh();
	    }
	}
	
	this.logout = function() {
		alert("Twitter Module Logout");
		$this.isLogin = false;
		$this.MTwitterList.clear();
		if ($this.isFocused) {
			$.sfScene.focus("Home");
		}
	}
	
	var $mTwitterThis = this;
    var autoRefreshInstance = null;
	
	var autoRefreshTime = 5*60*1000;
    var autoRefreshTimer;
	
    function startMtwitterHome() {
        var pParam = "count="+nCount;
        $mTwitterThis.TwitterAPI.statuses.home_timeline(
            function(pXMLHttpRequest, pSuccess) {
//                alert("pXMLHttpRequest.responseText:" + pXMLHttpRequest.responseText);
				if (!pSuccess) {
					Misc.networkErrPopup(function(){ widgetAPI.sendExitEvent();});
					return;
				}
                parseItem( jQuery.parseJSON( pXMLHttpRequest.responseText ), "FIRST" );
                $mTwitterThis.MTwitterList.displayPage(0);
				if ($this.isFocused)
					$mTwitterThis.MTwitterList.focus($this.arrContents.length < 1 ? 0 : 1);
				$this.iCommentInnerLoading.close();
				//Interactive Remote Start
				$this.MTwitterList.hideLoading();
				//Interactive Remote End
            }
        , false, pParam);
    }
    
    //Mini Widget
    function MiniFeed() {
        var id = "";
        var profile_pic = "";
        var name = "";
        var text = "";
        var updated_time = "";
    }
	
	$this.arrContents = [];
    
    function parseItem(pJSON, pType) {
        var i;
		bWait = false;
		if (!pJSON || !(pJSON instanceof Array) || pJSON.length < 1) {
			// Defect - P101014-0422
			if (pType == "FIRST") {
				$mTwitterThis.MTwitterList.addItems([]);
			}
			return;
		}
		var arrMiniFeed = new Array();
		for (var idx = 0; idx < pJSON.length; idx++) {
			if (pType == "AUTOREFRESH") {
				if (pJSON[idx].id == nLatest || pJSON[idx].id == nRefreshLatest) continue;
			} else if (pType == "MORE") {
				if (nOldest == pJSON[idx].id) continue;
			}
			
			// '\n' must be replaced with 'space'
			// because multiline ime is not supported.
			if (pJSON[idx].text && typeof pJSON[idx].text == "string") {
				pJSON[idx].text = pJSON[idx].text.replace(/\n/gi," ");
			} 
			
			//Set Data for Mini Widget
			arrMiniFeed[arrMiniFeed.length] = {
				id : pJSON[idx].id,
				profile_pic : pJSON[idx].user.profile_image_url,
				name : pJSON[idx].user.screen_name,
				text : pJSON[idx].text,
				updated_time : ExtractMessage(pJSON[idx], new Date(Date.parse(pJSON[idx].created_at)))
			} 
		}
		
		// Do nothing when there's no updated items
		if (arrMiniFeed.length < 1) return;
		
		if (pType != "AUTOREFRESH")
			$mTwitterThis.MTwitterList.addItems( arrMiniFeed );
			$mTwitterThis.MTwitterList.addRemoteServiceItem(arrMiniFeed,TWITTER_ID);
        switch(pType) {
            case "FIRST" :
            case "REFRESH" :
				$this.arrContents = arrMiniFeed;
                nTotalLength = arrMiniFeed.length;
                nLatest = arrMiniFeed[0].id;
                nOldest = arrMiniFeed[arrMiniFeed.length-1].id;
				TVComm.eventListener(TWITTER_ID, TVCHAT_EVENT_NEW, -1);
                break;
				
            case "MORE" :
				Util.insertArray($this.arrContents, arrMiniFeed, $this.arrContents.length);
				// Defect - P101013-0409
				// 		After 2nd Page, Focus is disappear when "More" action fail
				if (arrMiniFeed.length > 0) {
					nTotalLength += arrMiniFeed.length;
					nOldest = arrMiniFeed[arrMiniFeed.length - 1].id;
				}
				
				var nScrollTop = $mTwitterThis.MTwitterList.getScrollTop();
				
				$mTwitterThis.MTwitterList.displayPage($mTwitterThis.MTwitterList.getCurPage());
				$mTwitterThis.MTwitterList.blur($mTwitterThis.MTwitterList.getCurRealIdx());
				$mTwitterThis.MTwitterList.focus($mTwitterThis.MTwitterList.getCurRealIdx() + 1);
				
				// DMS00887860
				$mTwitterThis.MTwitterList.setScrollTop(nScrollTop);
                break;
				
            case "AUTOREFRESH" :
				nRefreshLatest = arrMiniFeed[0].id;
                TVComm.eventListener(TWITTER_ID, TVCHAT_EVENT_NEW, arrMiniFeed.length);
                break;
            default :
                break;
        }
    }
	
    function autoRefresh( pType ) {
        if( pType == "AUTOREFRESH" ) {
			//Interactive Remote Start
			$this.MTwitterList.autoRefresh();
			//Interactive Remote End
            $mTwitterThis.getHomeTimeline( "AUTOREFRESH" );
        }
        
        clearTimeout(autoRefreshInstance);
        autoRefreshInstance = setTimeout(function() {
            autoRefresh( "AUTOREFRESH" );
        }, autoRefreshTime);
    }
    
    this.refresh = function() {
		//Interactive Remote Start
		$this.MTwitterList.showLoading();
		//Interactive Remote End
		$this.iCommentInnerLoading.open();
        $mTwitterThis.MTwitterList.reset();
		bWait = true;
        startMtwitterHome();
    }
    
    this.getHomeTimeline = function( pType ) {
		var pParam = "";
		bWait = true;
        switch(pType) {
            case "MORE" :
				$this.iCommentInnerLoading.open();
				$this.MTwitterList.showLoading();
				$this.MTwitterList.setMoreFlag(TWITTER_ID);
                pParam = "max_id=" + nOldest + "&count=" + nCount;
                break;

            case "AUTOREFRESH" :
                pParam = "since_id=" + (nRefreshLatest ? nRefreshLatest : nLatest);
                break;

            default :
                break;
        }

        $mTwitterThis.TwitterAPI.statuses.home_timeline(
            function(pXMLHttpRequest, pSuccess) {
				bWait = false;
				if (pSuccess) {
//                	alert("pXMLHttpRequest.responseText:" + pXMLHttpRequest.responseText);
					parseItem(jQuery.parseJSON(pXMLHttpRequest.responseText), pType);
				} else {
					if (pType != "AUTOREFRESH") {
						Misc.networkErrPopup(function(pEvent){
							ctrlFocus();
							if(pEvent == EVENT_SOCIAL_KEY) {
								$this.returnToCategory();
							}
						});
					}
					autoRefresh();
				}
				$this.iCommentInnerLoading.close();
				$this.MTwitterList.hideLoading()
            }
        , false, pParam);
    }
    
    function ExtractMessage(status, date) {
        if (date == null) 
            return "";
        
        var now = new Date();
		
        var tmp_ms = now.getTime() - date.getTime();
        
		// Twitter Server Time is faster than Maple about 18 sec. (2011/01/19) 
		tmp_ms += 20 * 1000;
		
        var nDiffHour = Math.round(ConvertMSToHours(tmp_ms));
        var nDiffMin = Math.round(ConvertMSToMinutes(tmp_ms));
		var nDiffSec = Math.round(ConvertMSToSec(tmp_ms));
		
		nDiffSec = nDiffSec < 0 ? 0 : nDiffSec;
		
		var strReturn = "";
		
		if (nDiffHour >= 24) {
			strReturn = SOCIALTV_MIX_MONTH_DAY.Replace(ConvertMonthToString(date.getMonth() + 1),date.getDate());
		} else if (nDiffMin >= 60) {
			strReturn = (nDiffHour == 1) ? SID_ABOUT_AN_HOUR_AGO
                                    : SID_MIX_HOURS_AGO.Replace(nDiffHour);
		} else if (nDiffSec >= 60) {
			strReturn = (nDiffMin == 1) ? SID_ABOUT_A_MINUTE_AGO
                                    : SID_MIX_MINUTES_AGO.Replace(nDiffMin);			
		} else {
			strReturn = (nDiffSec == 1) ? SID_A_SECOND_AGO
                                    : SID_MIX_SECONDS_AGO.Replace(nDiffSec);
		}
		return strReturn;
    }
    
    function getSource(pStatus){
        var strSource = pStatus.source;
        var strName = "";
        
        if (strSource.indexOf("</a>") != -1) {
            var start = false;
            
            for (i = 0; i < strSource.length; i++) {
                if (start) 
                    strName += strSource[i];
                if (strSource[i] == '>') 
                    start = true;
                else 
                    if (i + 1 < strSource.length && strSource[i + 1] == '<') 
                        start = false;
            }
        }
        else 
            strName = strSource;
            
        return strName;
    }
    
    function replaceString(pString, pArgs) {
        var nArgLength = pArgs.length < 6 ? pArgs.length : 5;
        for(var idx = 0; idx < nArgLength; idx++) {
            pString = pString.replace(replaceString.arrSource[idx], pArgs[idx]);
        }
        return pString;
    }
    
    String.prototype.Replace = function() {	return replaceString(this, arguments); }
    replaceString.arrSource = ["<<A>>","<<B>>","<<C>>","<<D>>","<<E>>"];
    
    function ConvertMSToMinutes(ms) {
        return ms/1000/60;
    }
    
    function ConvertMSToHours(ms) {
        return ms/1000/60/60;
    }

    function ConvertMSToSec(ms) {
        return ms/1000;
    }
    
    function ConvertMonthToString(mon) {
        switch(mon)
        {
            case 1:
                return SID_JAN;
            case 2:
                return SID_FEB;
            case 3:
                return SID_MAR;
            case 4:
                return SID_APR;
            case 5:
                return SID_MAY;
            case 6:
                return SID_JUN;
            case 7:
                return SID_JUL;
            case 8:
                return SID_AUG; 
            case 9:
                return SID_SEP;
            case 10:
                return SID_OCT; 
            case 11:
                return SID_NOV;
            case 12:
                return SID_DEC;
        }
        return ""; 
    }
    
	this.showHelpNav = function() {
		if (TVComm.getAccount(TWITTER_ID).id) {
			$("#HomeHelp").sfKeyHelp({
		        'user': TVComm.getAccount(TWITTER_ID).id
				,'red' : TVComm.getSSOID() ? SID_LOGOUT : SID_LOGIN
		        ,'green': SID_REFRESH 
		        ,'blue': TV_SID_CHANGE_VIEW
		        ,'tools': SID_SETTINGS
		        ,'return': SID_EXIT
		    });
		} else {
			$("#HomeHelp").sfKeyHelp({
				'red' : TVComm.getSSOID() ? SID_LOGOUT : SID_LOGIN
		        , 'blue': TV_SID_CHANGE_VIEW
		        ,'tools': SID_SETTINGS
		        ,'return': SID_EXIT
			});		
		}
	}

	    /*
     	Function: ctrlFocus
     			Focus the scene which is correct up to situation

     	Parameters:
     			N/A
     	Returns:
     			N/A
     */
	function ctrlFocus() {
		if ($mTwitterThis.isFocused) {
			// Focus to category for service change
			focusCurScene();
		} else {
			$.sfScene.focus("Home");
		}
	}
	
	    /*
     	Function: focusCurScene
     			Focus current scene

     	Parameters:
     			N/A
     	Returns:
     			N/A
     */
	function focusCurScene() {
		$.sfScene.focus({
			id: "SNSList",
			scope: TWITTER_ID
		});
	}
	/*
     	Function: isYourVideoGlobal
     			Check global option is true in your video
     			
     	Returns:
     			true | false
     */
	function isYourVideoGlobal() {
		var yourVideoData = readCommonFile(sYourVideoID, '_sfdata.json');
		if (yourVideoData) {	// YourVideo 파일이 있음.
			try {	// file이 깨졌을 경우의 처리
				yourVideoData = (yourVideoData == '') ? null : $.parseJSON(yourVideoData);
			} catch(e)  {
				return isYourVideoGlobal.ERROR;
				alert ;
			}
			useGlobal = yourVideoData['setting_useGlobal'];
			alert("[Twitter SNSList.js] isYourVideoGlobal returns " + useGlobal, 0);
			if (useGlobal) {
				return isYourVideoGlobal.TRUE;
			} else {
				return isYourVideoGlobal.FALSE;
			}
		}
		return isYourVideoGlobal.NONE;
	}
	
	isYourVideoGlobal.TRUE = 100;
	isYourVideoGlobal.FALSE = 101;
	isYourVideoGlobal.NONE = 998;
	isYourVideoGlobal.ERROR = 999;

	/*
     	Function: readCommonFile
     			Utility to read common file.
     			This module will be replaced with Util.readCommonFile().

     	Parameters:
     			 String -	 Filepath
     			 String - Filename
     	Returns:
     			String - File contents
     */
	function readCommonFile(dir, file) {
	    alert('[SocialTV] readCommonFile(' + dir + ',' + file + ')');
	    var FS = new FileSystem();
	    if (FS.isValidCommonPath(dir) != 1) {
	        alert('[SocialTV] directory is not found : ' + dir);
	        return null;
	    }
	    var FP = FS.openCommonFile(dir + '/' + file, 'r');
	    if (!FP) {
	        alert('[SocialTV] file is not found : ' + file);
	        return null;
	    }
	    var result = FP.readAll();
	    alert('[SocialTV] loaded data : ' + result);
	    FS.closeFile(FP);
	    return result;
	}
}

SceneSNSList.prototype.initialize = function (pReset) {
	alert("MTwitter.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
	if (!this.init || pReset) {
		this.init = true;
	} else {
		return;
	}
	
	var $this = this;
	
    $this.MTwitterList = new CVLList({
		id : TWITTER_ID
		, div : document.getElementById("MTwitter")
		, headerFocus : true
		, width : 285, height : 429
	});
	
	$this.MTwitterList.setRenderer(function(pContents){
		var strHTML = "";
		strHTML += "<table>";
		strHTML += "<tr><td = 'width:15px;'></td><td style = 'width:56px;vertical-align:top;'>";
		strHTML += "<div style ='width:56px;height:56px;background-image:url(images/tvchat_photo_bg.png);'>";
		strHTML += "<img src = '" + pContents.profile_pic + "' style = 'position:relative;width:48px;height:48px;left:3px;top:3px'>";
		strHTML += "</div>";
		strHTML += "</td><td style = 'width:200px'>";
		strHTML += "<div style = 'position:absolute;top:6px;left:67px;color:#FFFFFF;'>";
		strHTML += pContents.name;
		strHTML += "</div>";
		strHTML += "<div style = 'position:absolute;top:5px;left:66px;color:#004f8c;'>";
		strHTML += pContents.name;
		strHTML += "</div>";
		strHTML += "<br>";
		strHTML += "<div>";
		strHTML += Util.seperateString(pContents.text);
		strHTML += "</div>";
		strHTML += "</td></tr>";
		strHTML += "</table>";
        strHTML += "<div style = 'position:relative;height:25px;'>";
		strHTML += "<div style = 'position:absolute;right:10px;height:20px;top:5px;text-align:right;color:#FFFFFF;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:250px;'>"+pContents.updated_time+"</div>";
		strHTML += "<div style = 'position:absolute;right:11px;height:20px;top:5px;text-align:right;color:#002b43;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:250px;'>"+pContents.updated_time+"</div>";
		strHTML += "</div>";
		return strHTML;
	});
    
    $this.MTwitterList.setHeaderRenderer(function(pContents){
		var strHTML = "";
		strHTML += "<table>";
		strHTML += "<tr><td style = 'font-size:15px;width:279px;height:24px;text-align:center;vertical-align:middle;'>";
		strHTML += TWID_WHATS_HAPPENING;
		strHTML += "</td></tr></table>";
		return strHTML;
	});
    
	$this.iCommentInnerLoading = new innerLoading({
	    id: "MTwitterLoading",
	    container: document.getElementById("MTwitterLoading")
		, left : 770
		, top : 230
	});
	$this.TwitterAPI = new TwitterAPI("4H7Zaq22K4iepHECZtuQQ","zAwknNl1Qbn4ZWcYhncUOq7Rmp136uVHjOQcxmZFN04");
	$this.login();
}

SceneSNSList.prototype.handleShow = function () {
	alert("MTwitter.handleShow()");
	// this function will be called when the scene manager show this scene
	this.showHelpNav();
	this.MTwitterList.onShow();
}

SceneSNSList.prototype.handleHide = function () {
	alert("MTwitter.handleHide()");
	// this function will be called when the scene manager hide this scene
	
	this.MTwitterList.blur(this.MTwitterList.getCurRealIdx()+1);  
}

SceneSNSList.prototype.handleFocus = function () {
	alert("MTwitter.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	this.isFocused = true;
	
	// If service is not available, focus to top category	
	if (!TVComm.getAccount(TWITTER_ID).id) {
		this.MTwitterList.blur(this.MTwitterList.getCurRealIdx()+1);
		$.sfScene.focus("Home");
		return;
	}
	
	// Focus to category for service change
	this.MTwitterList.focus(this.MTwitterList.getCurRealIdx()+1);
	
	// When return from submenu, restore help navi setting
	this.showHelpNav();
}

SceneSNSList.prototype.handleBlur = function () {
	alert("MTwitter.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneSNSList.prototype.handleKeyDown = function (keyCode) {
	alert("MTwitter.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	if (!Util.commonKeyHandler(keyCode)) return;
	var $this = this;
	
	if(keyCode != $.sfKey.EXIT  && bWait) return;
	
	switch (keyCode) {
		case $.sfKey.LEFT:
			$.sfScene.get("Home").prevService();
			break;
		case $.sfKey.RIGHT:
			$.sfScene.get("Home").nextService();
			break;
		case $.sfKey.UP:
			if (this.MTwitterList.getCurRealIdx() > -1) {
				this.MTwitterList.prevItem();
			} else {
				// Focus to category for service change
				$.sfScene.focus("Home");
				this.MTwitterList.blur(this.MTwitterList.getCurRealIdx()+1);
				this.isFocused = false;
				this.showServiceInfo();
			}
			break;
		case $.sfKey.DOWN:
            if( this.MTwitterList.getCurRealIdx() == ( nTotalLength - 1 ) ) {
                this.getHomeTimeline( "MORE" );
            }
            else {
                this.MTwitterList.nextItem();
            }
			break;
		case $.sfKey.FF:
			this.MTwitterList.nextPage();
			break;
		case $.sfKey.RW:
			this.MTwitterList.prevPage();
			break;
		case $.sfKey.ENTER:
			if (CommonPlugin.isViewerKey($.sfKey.ENTER)) return;
			if ($this.iCommentInnerLoading.isLoading()) return;
			this.enter(this.arrContents[this.MTwitterList.getCurRealIdx()]);
			break;
		case $.sfKey.RED:
			TVComm.openSSO();
			break;			
		case $.sfKey.BLUE:
			TVComm.changeMode();
			break;
        case $.sfKey.GREEN:
			if ($this.isLogin){
			this.updateRefreshFlag();
			this.refresh();
			}
			break;
        case $.sfKey.TOOLS:
			$.sfKey.block();
            this.tools();
			break;
		case $.sfKey.RETURN:
		case SOCIAL_TV_KEY:	
			this.returnToCategory();
			//Interactive Remote Start
			this.showServiceInfo();
			//Interactive Remote End

			break;
		case $.sfKey.EXIT:
			$.sfKey.block();
			TVComm.returnEvent();
			break;
	}
}