function CPSearch() {
	var $this = this;
	this.ver = 0.102;
	
	this.cpName = 'Twitter';
	this.libs = [];
	this.icon = 'img/twitter.png';

	var REQ_STATUS = {
		SUCCESS : 1,
		XHR_ERROR : 10,
		NO_DATA : 11
	}

	var curKeyword = "";
	var resultList = [];
	var resultRef = [];	
	
	/*
     Function: request
     		Interface
     
     Parameters:
     		pkeyword - Key word
     		pStart - Start Index (0-based)
     		pLength - Request data length 
     		pCallback - Callback Function 
     */
	this.request = function (pkeyword, pStart, pLength, pCallback) {
		if (curKeyword != encodeURIComponent(pkeyword) || pStart == 1) {
			resultList = []; 
			resultRef = [];
			curKeyword = encodeURIComponent(pkeyword);
		}
		if (pStart + pLength < resultList.length) {
			pCallback(makeResult(REQ_STATUS.SUCCESS, pStart, pLength));
			return ;
		}
		var XMLHttpRequest = createXHRObject();
		XMLHttpRequest.onreadystatechange = function(){
			if (XMLHttpRequest.readyState == 4) {
				var reqStatus = generateList(XMLHttpRequest, pStart, pLength);
				if (reqStatus == REQ_STATUS.SUCCESS) {
					pCallback(makeResult(reqStatus, pStart, pLength));
				} else {
					pCallback(makeResult(reqStatus));
				}
			}
		};
		XMLHttpRequest.open("GET", getQueryURL(pStart, pLength));
		XMLHttpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded;charset=utf-8");
		XMLHttpRequest.send();
	}

	this.cancel = function() {}
	
	function getQueryURL(pStart, pLength) {
		var strURL = "";
		if (resultList.length == 0) {
			strURL = "http://search.twitter.com/search.json?q="+curKeyword+"&rpp="+pLength;
		} else {
			strURL = "http://search.twitter.com/search.json"+resultRef[pStart-2].next;
		}
		return strURL;
	}
	
	function makeResult(pStatus, pStart, pLength) {
		var objResult = {};
		objResult.cpName = $this.cpName;
		if (pStatus == REQ_STATUS.SUCCESS) {
			objResult.data = resultList.slice(pStart - 1, pStart + pLength);
		} else {
			// Search Failed
			objResult.error = pStatus;
		}
		return objResult;
	}
	
	/*
     Function: generateList
     Parameters:
     Returns:
     */
	function generateList(pXHR, pStart, pLength) {
		if (pXHR.status == 200) {
			var resultJSON = $.parseJSON(pXHR.responseText);
			if (resultJSON.results) {
				resultRef[pStart + pLength - 2] = { 	'next': resultJSON.next_page   };
				var nLength = resultJSON.results.length;
				var tempResult;
				if (nLength > 0) {
					for (var idx = 0; idx < nLength; idx++) {
						tempResult = resultJSON.results[idx];
						resultList[pStart+idx-1] = {
							field1: {		value: tempResult.text 	},
							field2: { 	value: new Date(tempResult.created_at), type: 'date' 	}, 
							runInfo: tempResult.id
						};
					}
				}
			}
			else {
				return REQ_STATUS.NO_DATA;
			}
		} else {
			// XHR status is not 200
			return REQ_STATUS.XHR_ERROR;
		}
		return REQ_STATUS.SUCCESS;
	}
	
    /*
     Function: createXHRObject
     		Create XMLHttpRequest Object
     
     Returns:
     		XMLHttpRequest Object
     */
	function createXHRObject(){
		return new window.XMLHttpRequest;
	}
}
